#!/usr/bin/env python
# coding: utf-8

# # Import dat

# In[1]:


import pandas as pd

df = pd.read_csv('FinancialsData.csv', sep=';',encoding='cp1252')

print(df)


# In[2]:


print(df.iloc[2,1])


# In[3]:


for index, row in df.iterrows():
    print(index, row['name'])


# In[2]:


df.columns


# In[3]:


df.rename(columns={'classification ': 'classification'}, inplace=True)
df.columns


# In[4]:


df.loc[df['classification'] == "chip design"]


# In[7]:


# funguje pouze po převedení na float
#df.loc[df['r2019'] > 70000]


# In[4]:


df.columns


# # Dummy variables

# In[9]:


#pd.get_dummies(df.classification)


# In[5]:


embarked_dummies = pd.get_dummies(df.classification, prefix='Classification').iloc[:, 1:]


# In[6]:


df = pd.concat([df, embarked_dummies], axis=1)


# In[7]:


df.head()


# In[13]:


#import numpy as np

#df = pd.DataFrame({'classification': ['chip design', 'data infrastructure', 'foundry', 'consumables for production ', 
#                                      'photolithography machines', 'wireless communications', 
#                                      'products for gas analysis and control', 'assembly'],
#                   })

#print(df)

#pd.get_dummies(df)


# # Úprava mezer za názvem sloupce

# In[8]:


df.rename(columns={'Classification_consumables for production ': 'Classification_consumables for production'}, inplace=True)
df.columns


# # Nejvyšší Gross Profit ratio (níže lepší)

# In[9]:


#f[gpr2020] = le.fit_transform(df[gpr2020].astype(str))
col_max = max(df['gpr2020'].astype(str))
col_max


# In[13]:


col_max = max(df['gpr2019'].astype(str))
col_max


# In[17]:


#max_index = df.idmax()
#max_index


# In[14]:


col_min = min(df['gpr2020'].astype(str))
col_min


# In[15]:


max(df['gpr2020'].astype(str))


# In[20]:


#col_max = df['gpr2019'].max(axis=0)
#col_max


# # Nejvyšší revenue

# In[11]:


#převedení na float
df['r2010'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['r2010'].values]
df['r2011'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['r2011'].values]
df['r2012'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['r2012'].values]
df['r2013'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['r2013'].values]
df['r2014'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['r2014'].values]
df['r2015'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['r2015'].values]
df['r2016'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['r2016'].values]
df['r2017'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['r2017'].values]
df['r2018'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['r2018'].values]
df['r2019'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['r2019'].values]
df['r2020'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['r2020'].values]
df['r2021'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['r2021'].values]


# In[12]:


print(df['r2010'].dtype)
print(df['r2011'].dtype)
print(df['r2012'].dtype)
print(df['r2013'].dtype)
print(df['r2014'].dtype)
print(df['r2015'].dtype)
print(df['r2016'].dtype)
print(df['r2017'].dtype)
print(df['r2018'].dtype)
print(df['r2019'].dtype)
print(df['r2020'].dtype)
print(df['r2021'].dtype)


# In[11]:


col_max = df['r2019'].max(axis=0)
col_max


# In[13]:


print(df['r2019'])


# In[20]:


col_max = df['r2019'].max(axis=0)
col_max


# In[21]:


df['r2019'].idxmax()
#max_index = df.idxmax()
#max_index


# In[22]:


print(df['r2020'])


# In[23]:


col_max = df['r2020'].max(axis=0)
col_max


# In[24]:


df['r2020'].idxmax()


# In[17]:


max_index = df['r2020'].idxmax()
ticker = df.loc[max_index, 'ticker']
name = df.loc[max_index, 'name']
print(ticker)
print(name)


# # Nejvyšší Gross Profit ratio

# In[14]:


df['gpr2019'] = df['gpr2019'].str.rstrip('%')
df['gpr2019'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gpr2019'].values]


# In[15]:


df['gpr2019'] = (df['gpr2019'] / 100)


# In[16]:


print(df['gpr2019'])


# In[29]:


col_max = df['gpr2019'].max(axis=0)
col_max


# In[17]:


print(df['gpr2019'].dtype)


# In[31]:


df['gpr2019'].idxmax()


# In[32]:


max_index = df['gpr2019'].idxmax()
#max_index
ticker = df.loc[max_index, 'ticker']
name = df.loc[max_index, 'name']
print(ticker)
print(name)


# In[33]:


ticker = df.loc[max_index, 'ticker']
name = df.loc[max_index, 'name']
print(ticker)
print(name)


# In[19]:


df['gpr2020'] = df['gpr2020'].str.rstrip('%')
df['gpr2020'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gpr2020'].values]


# In[20]:


df['gpr2020'] = (df['gpr2020'] / 100)


# In[21]:


print(df['gpr2020'])


# In[37]:


col_max = df['gpr2020'].max(axis=0)
col_max


# In[38]:


df['gpr2020'].idxmax()


# In[18]:


max_index = df['gpr2020'].idxmax()
ticker = df.loc[max_index, 'ticker']
name = df.loc[max_index, 'name']
print(ticker)
print(name)


# # Nejvyšší Gross Profit ratio (procenta, ticker, název)

# In[22]:


df['gpr2010'] = df['gpr2010'].str.rstrip('%')
df['gpr2010'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gpr2010'].values]
df['gpr2010'] = (df['gpr2010'] / 100)


# In[23]:


col_max = df['gpr2010'].max(axis=0)
print(col_max * 100, "%")
max_index = df['gpr2010'].idxmax()
ticker = df.loc[max_index, 'ticker']
name = df.loc[max_index, 'name']
print(ticker)
print(name)


# In[24]:


df['gpr2021'] = df['gpr2021'].str.rstrip('%')
df['gpr2021'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gpr2021'].values]
df['gpr2021'] = (df['gpr2021'] / 100)


# In[25]:


col_max = df['gpr2021'].max(axis=0)
print(col_max * 100, "%")
max_index = df['gpr2021'].idxmax()
ticker = df.loc[max_index, 'ticker']
name = df.loc[max_index, 'name']
print(ticker)
print(name)


# In[26]:



col_max = df['gpr2010'].max(axis=0)
print(col_max * 100, "%")
max_index = df['gpr2010'].idxmax()
ticker = df.loc[max_index, 'ticker']
name = df.loc[max_index, 'name']
print(ticker)
print(name)


# # Nejvyšší nárůst tržeb mezi lety

# In[27]:


growth = df
growth['2019-2013 variation'] = (growth['r2019'] / growth['r2013']) - 1
growth = growth.sort_values(['2019-2013 variation'],ascending=False)
print("Nejvyšší nárůst tržeb od roku 2013 do 2019")
print(growth.head(5)[['ticker', 'name', '2019-2013 variation']])


# In[19]:


growth['gr2010/11'] = (growth['r2011'] / growth['r2010']) - 1
growth = growth.sort_values(['gr2010/11'],ascending=False)
print("Nejvyšší nárůst tržeb mezi lety 2010 - 2011")
print(growth.head(5)[['ticker', 'name', 'gr2010/11']])


# In[20]:


growth['gr2011/12'] = (growth['r2012'] / growth['r2011']) - 1
growth = growth.sort_values(['gr2011/12'],ascending=False)
#procenta growth['grw2011/12'] = (growth['gr2011/12'] * 100)
print("Nejvyšší nárůst tržeb mezi lety 2011 - 2012")
print(growth.head(5)[['ticker', 'name', 'gr2011/12']])


# # Graf

# In[28]:


import matplotlib.pyplot as plt


# In[29]:


index = df['ticker']
index


# In[30]:


data = {'index':df['ticker'],
        'r2021':df['r2021'],
        'r2020':df['r2020'],
        'r2019':df['r2019'],
        'r2018':df['r2018'],
        'r2017':df['r2017'],
        'r2016':df['r2016'],
        'r2015':df['r2015'],
        'r2014':df['r2014'],
        'r2013':df['r2013'],
        'r2012':df['r2012'],
        'r2011':df['r2011'],
        'r2010':df['r2010'],
        }


# Convert the dictionary into DataFrame 
x = pd.DataFrame(data)
  
 
x[['index', 'r2021', 'r2020', 'r2019', 'r2018', 'r2017', 'r2016']]


# In[31]:


# nastavení ticker jako index
plotdata = pd.DataFrame(data)

plotdata.set_index('index', inplace=True)


plotdata.head(10)


# In[32]:


plotdata = plotdata.fillna(0)


# In[33]:


plotdata = plotdata[plotdata.columns[::-1]]


# In[54]:


stacked_data = plotdata.apply(lambda x: x*100/sum(x), axis=1)
stacked_data.plot(kind="bar", stacked=True)
plt.title("Mince Pie Consumption Breakdown")
plt.xlabel("Family Member")
plt.ylabel("Percentage Pies Consumed (%)")


# In[40]:


# transpose dat:  osa x -> roky
plotdata.transpose()


# # Skládaný graf tržby (100%)

# In[55]:


plotdata.transpose().apply(lambda x: x*100/sum(x), axis=1).plot(kind="area", stacked=True)
plt.title("Revenue")
plt.xlabel("Year")
plt.ylabel("Revenue (%)")
plt.rcParams["figure.figsize"] = [20, 12]
plt.legend(bbox_to_anchor=(1.0, 1.0))
#plt.legend(reversed(handles), reversed(labels))


# # Skládaný graf tržby

# In[56]:


g = plotdata.transpose().plot(kind="area", stacked=True)
#plt.title("Tržby firem")
plt.xlabel("Rok")
plt.ylabel("Tržby (mld. $)")
plt.rcParams["figure.figsize"] = [20, 12]
#plt.legend(bbox_to_anchor=(1.0, 1.0))
#g.legend(ncol=3)
plt.xlim([0, 11])
x = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
labels = ['2010', '2011', '2012', '2013', '2014', '2015', '2016', '2017', '2018', '2019', '2020', '2021']
plt.xticks(x, labels)
current_handles, current_labels = plt.gca().get_legend_handles_labels()
reversed_handles = list(reversed(current_handles))
reversed_labels = list(reversed(current_labels))
plt.legend(reversed_handles,reversed_labels, ncol=2)

ylabels = ['{:,.0f}'.format(x) for x in g.get_yticks()/1000]
g.set_yticklabels(ylabels)

#ticks=get(gca,'YTicks');%retrieve current ticks
#ticks=ticks*1000;%multiply
#ticks=cellfun(@num2str,tick,'UniformOutput',false);%convert to cellstr
#set(gca,'YTickLabels',ticks)%set new tick labels

SMALL_SIZE = 10
MEDIUM_SIZE = 13
BIGGER_SIZE = 15
TITLE_SIZE = 17
HUGE_SIZE = 19

plt.rc('font', size=SMALL_SIZE)           # controls default text sizes
plt.rc('axes', titlesize=HUGE_SIZE)     # fontsize of the axes title
plt.rc('axes', labelsize=HUGE_SIZE)     # fontsize of the x and y labels
plt.rc('xtick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('ytick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('legend', fontsize=TITLE_SIZE)    # legend fontsize
plt.rc('figure', titlesize=HUGE_SIZE)   # fontsize of the figure title
#plt.rcParams.update({'font.size': 50})
g.legend(ncol=3)
#plt.grid(visible=None, which='major', axis='both')
#plt.grid(True)
#ax.set_axisbelow(True)
#ax.yaxis.grid(color='gray', linestyle='dashed')
#plt.legend(reversed(plt.legend().legendHandles), reversed(labels))
#plt.legend(reversed(handles), reversed(labels))


# In[57]:


print(df)


# # Df pro jednotlivé dummy

# In[58]:


df.columns


# In[59]:


df_chipdesign = df.loc[(df['classification'] == "chip design")]
df_chipdesign


# In[66]:


#df_chipdesign = df.loc[(df['Classification_chip design'] == 1)]
#df_chipdesign


# In[60]:


df_consumablesforproduction = df.loc[(df['Classification_consumables for production'] == 1)]
df_consumablesforproduction


# In[61]:


df_foundry = df.loc[(df['Classification_foundry'] == 1)]
df_foundry


# In[62]:


df_products = df.loc[(df['Classification_products'] == 1)]
df_products


# In[70]:


#df_datainfrastructure = df.loc[(df['Classification_data infrastructure'] == 1)]
#df_datainfrastructure


# In[71]:


#df_photolithographymachines = df.loc[(df['Classification_photolithography machines'] == 1)]
#df_photolithographymachines


# In[72]:


#df_productsforgasanalysisandcontrol = df.loc[(df['Classification_products for gas analysis and control'] == 1)]
#df_productsforgasanalysisandcontrol


# In[73]:


#df_wirelesscommunications = df.loc[(df['Classification_wireless communications'] == 1)]
#df_wirelesscommunications


# In[74]:


#df_assembly = df.loc[(df['classification'] == "assembly")]
#df_assembly


# # Nejvyšší tržby pro jednotlivé dummy 2020

# In[63]:


max_index = df['r2020'].idxmax()
ticker = df.loc[max_index, 'ticker']
name = df.loc[max_index, 'name']
revenue = df.loc[max_index, 'r2020']
print("Nejvyšší tržby za rok 2020")
print(ticker)
print(name)
print(revenue, "$ (mln.)")
print()

max_index = df_chipdesign['r2020'].idxmax()
ticker = df_chipdesign.loc[max_index, 'ticker']
name = df_chipdesign.loc[max_index, 'name']
revenue = df_chipdesign.loc[max_index, 'r2020']
print("Nejvyšší tržby za rok 2020, společnosti zaměřené na chip design")
print(ticker)
print(name)
print(revenue, "$ (mln.)")
print()

max_index = df_consumablesforproduction['r2020'].idxmax()
ticker = df_consumablesforproduction.loc[max_index, 'ticker']
name = df_consumablesforproduction.loc[max_index, 'name']
revenue = df_consumablesforproduction.loc[max_index, 'r2020']
print("Nejvyšší tržby za rok 2020, společnosti zaměřené na consumables pro produkci")
print(ticker)
print(name)
print(revenue, "$ (mln.)")
print()

max_index = df_foundry['r2020'].idxmax()
ticker = df_foundry.loc[max_index, 'ticker']
name = df_foundry.loc[max_index, 'name']
revenue = df_foundry.loc[max_index, 'r2020']
print("Nejvyšší tržby za rok 2020, společnosti zaměřené na foundry")
print(ticker)
print(name)
print(revenue, "$ (mln.)")
print()

max_index = df_products['r2020'].idxmax()
ticker = df_products.loc[max_index, 'ticker']
name = df_products.loc[max_index, 'name']
revenue = df_products.loc[max_index, 'r2020']
print("Nejvyšší tržby za rok 2020, společnosti zaměřené na produkty")
print(ticker)
print(name)
print(revenue, "$ (mln.)")
print()


# # Nejvyšší tržby pro jednotlivé dummy 2021

# In[64]:


max_index = df['r2021'].idxmax()
ticker = df.loc[max_index, 'ticker']
name = df.loc[max_index, 'name']
revenue = df.loc[max_index, 'r2021']
print("Nejvyšší tržby za rok 2021")
print(ticker)
print(name)
print(revenue, "$ (mln.)")
print()

max_index = df_chipdesign['r2021'].idxmax()
ticker = df_chipdesign.loc[max_index, 'ticker']
name = df_chipdesign.loc[max_index, 'name']
revenue = df.loc[max_index, 'r2021']
print("Nejvyšší tržby za rok 2021, společnosti zaměřené na chip design")
print(ticker)
print(name)
print(revenue, "$ (mln.)")
print()

max_index = df_consumablesforproduction['r2021'].idxmax()
ticker = df_consumablesforproduction.loc[max_index, 'ticker']
name = df_consumablesforproduction.loc[max_index, 'name']
revenue = df.loc[max_index, 'r2021']
print("Nejvyšší tržby za rok 2021, společnosti zaměřené na consumables pro produkci")
print(ticker)
print(name)
print(revenue, "$ (mln.)")
print()

max_index = df_foundry['r2021'].idxmax()
ticker = df_foundry.loc[max_index, 'ticker']
name = df_foundry.loc[max_index, 'name']
revenue = df.loc[max_index, 'r2021']
print("Nejvyšší tržby za rok 2021, společnosti zaměřené na foundry")
print(ticker)
print(name)
print(revenue, "$ (mln.)")
print()

max_index = df_products['r2021'].idxmax()
ticker = df_products.loc[max_index, 'ticker']
name = df_products.loc[max_index, 'name']
revenue = df.loc[max_index, 'r2021']
print("Nejvyšší tržby za rok 2021, společnosti zaměřené na produkty")
print(ticker)
print(name)
print(revenue, "$ (mln.)")
print()


# # Nejvyšší nárůst tržeb mezi lety 2013 a 2019 (první a poslední kompletní data v těchto letech)

# In[65]:


growth = df
growth['2019-2013 variation'] = (growth['r2019'] / growth['r2013']) - 1
growth = growth.sort_values(['2019-2013 variation'],ascending=False)
print("Nejvyšší nárůst tržeb od roku 2013 do 2019")
print(growth.head(5)[['ticker', 'name', '2019-2013 variation']])
print()

max_index = growth['2019-2013 variation'].idxmax()
ticker = df.loc[max_index, 'ticker']
name = df.loc[max_index, 'name']
rust = df.loc[max_index, '2019-2013 variation']
print("Nejvyšší růst tržeb mezi lety 2013 - 2019")
print(ticker)
print(name)
print(rust * 100, "%")
print()

max_index = df_chipdesign['2019-2013 variation'].idxmax()
ticker = df_chipdesign.loc[max_index, 'ticker']
name = df_chipdesign.loc[max_index, 'name']
rust = df.loc[max_index, '2019-2013 variation']
print("Nejvyšší růst tržeb mezi lety 2013 - 2019, společnosti zaměřené na chip design")
print(ticker)
print(name)
print(rust * 100, "%")
print()

max_index = df_consumablesforproduction['2019-2013 variation'].idxmax()
ticker = df_consumablesforproduction.loc[max_index, 'ticker']
name = df_consumablesforproduction.loc[max_index, 'name']
rust = df.loc[max_index, '2019-2013 variation']
print("Nejvyšší růst tržeb mezi lety 2013 - 2019, společnosti zaměřené na consumables for production")
print(ticker)
print(name)
print(rust * 100, "%")
print()

max_index = df_foundry['2019-2013 variation'].idxmax()
ticker = df_foundry.loc[max_index, 'ticker']
name = df_foundry.loc[max_index, 'name']
rust = df.loc[max_index, '2019-2013 variation']
print("Nejvyšší růst tržeb mezi lety 2013 - 2019, společnosti zaměřené na foundry")
print(ticker)
print(name)
print(rust * 100, "%")
print()

max_index = df_products['2019-2013 variation'].idxmax()
ticker = df_products.loc[max_index, 'ticker']
name = df_products.loc[max_index, 'name']
rust = df.loc[max_index, '2019-2013 variation']
print("Nejvyšší růst tržeb mezi lety 2013 - 2019, společnosti zaměřené na produkty")
print(ticker)
print(name)
print(rust * 100, "%")
print()


# # Nejvyšší nárůst tržeb mezi lety 2010 a 2011

# In[66]:


df_chipdesign = df.loc[(df['classification'] == "chip design")]
df_consumablesforproduction = df.loc[(df['Classification_consumables for production'] == 1)]
df_foundry = df.loc[(df['Classification_foundry'] == 1)]
df_products = df.loc[(df['Classification_products'] == 1)]


# In[68]:


growth = df
growth['gr1011'] = (growth['r2011'] / growth['r2010']) - 1
growth = growth.sort_values(['gr1011'],ascending=False)
print("Nejvyšší nárůst tržeb mezi lety 2010 - 2011")
print(growth.head(5)[['ticker', 'name', 'gr1011']])
print()

max_index = growth['gr1011'].idxmax()
ticker = df.loc[max_index, 'ticker']
name = df.loc[max_index, 'name']
rust = df.loc[max_index, 'gr1011']
print("Nejvyšší růst tržeb mezi lety 2010 - 2011")
print(ticker)
print(name)
print(rust * 100, "%")
print()

max_index = df_chipdesign['gr1011'].idxmax()
ticker = df_chipdesign.loc[max_index, 'ticker']
name = df_chipdesign.loc[max_index, 'name']
rust = df.loc[max_index, 'gr1011']
print("Nejvyšší růst tržeb mezi lety 2010 - 2011, společnosti zaměřené na chip design")
print(ticker)
print(name)
print(rust * 100, "%")
print()

max_index = df_consumablesforproduction['gr1011'].idxmax()
ticker = df_consumablesforproduction.loc[max_index, 'ticker']
name = df_consumablesforproduction.loc[max_index, 'name']
rust = df.loc[max_index, 'gr1011']
print("Nejvyšší růst tržeb mezi lety 2010 - 2011, společnosti zaměřené na consumables for production")
print(ticker)
print(name)
print(rust * 100, "%")
print()

max_index = df_foundry['gr1011'].idxmax()
ticker = df_foundry.loc[max_index, 'ticker']
name = df_foundry.loc[max_index, 'name']
rust = df.loc[max_index, 'gr1011']
print("Nejvyšší růst tržeb mezi lety 2010 - 2011, společnosti zaměřené na foundry")
print(ticker)
print(name)
print(rust * 100, "%")
print()

max_index = df_products['gr1011'].idxmax()
ticker = df_products.loc[max_index, 'ticker']
name = df_products.loc[max_index, 'name']
rust = df.loc[max_index, 'gr1011']
print("Nejvyšší růst tržeb mezi lety 2010 - 2011, společnosti zaměřené na produkty")
print(ticker)
print(name)
print(rust * 100, "%")
print()


# # Nejvyšší Gross Profit ratio 2021

# In[69]:


max_index = growth['gpr2021'].idxmax()
ticker = df.loc[max_index, 'ticker']
name = df.loc[max_index, 'name']
gpr = df.loc[max_index, 'gpr2021']
print("Nejvyšší Gross Profit ratio 2021")
print(ticker)
print(name)
print(gpr * 100, "%")
print()

max_index = df_chipdesign['gpr2021'].idxmax()
ticker = df_chipdesign.loc[max_index, 'ticker']
name = df_chipdesign.loc[max_index, 'name']
gpr = df.loc[max_index, 'gpr2021']
print("Nejvyšší Gross Profit ratio 2021, společnosti zaměřené na chip design")
print(ticker)
print(name)
print(gpr * 100, "%")
print()

max_index = df_consumablesforproduction['gpr2021'].idxmax()
ticker = df_consumablesforproduction.loc[max_index, 'ticker']
name = df_consumablesforproduction.loc[max_index, 'name']
gpr = df.loc[max_index, 'gpr2021']
print("Nejvyšší Gross Profit ratio 2021, společnosti zaměřené na consumables for production")
print(ticker)
print(name)
print(gpr * 100, "%")
print()

max_index = df_foundry['gpr2021'].idxmax()
ticker = df_foundry.loc[max_index, 'ticker']
name = df_foundry.loc[max_index, 'name']
gpr = df.loc[max_index, 'gpr2021']
print("Nejvyšší Gross Profit ratio 2021, společnosti zaměřené na foundry")
print(ticker)
print(name)
print(gpr * 100, "%")
print()

max_index = df_products['gpr2021'].idxmax()
ticker = df_products.loc[max_index, 'ticker']
name = df_products.loc[max_index, 'name']
gpr = df.loc[max_index, 'gpr2021']
print("Nejvyšší Gross Profit ratio 2021, společnosti zaměřené na produkty")
print(ticker)
print(name)
print(gpr * 100, "%")
print()


# # Nejvyšší Gross Profit ratio 2020

# In[74]:


max_index = growth['gpr2020'].idxmax()
ticker = df.loc[max_index, 'ticker']
name = df.loc[max_index, 'name']
gpr = df.loc[max_index, 'gpr2020']
print("Nejvyšší Gross Profit ratio 2020")
print(ticker)
print(name)
print(gpr * 100, "%")
print()

max_index = df_chipdesign['gpr2020'].idxmax()
ticker = df_chipdesign.loc[max_index, 'ticker']
name = df_chipdesign.loc[max_index, 'name']
gpr = df.loc[max_index, 'gpr2020']
print("Nejvyšší Gross Profit ratio 2020, společnosti zaměřené na chip design")
print(ticker)
print(name)
print(gpr * 100, "%")
print()

max_index = df_consumablesforproduction['gpr2020'].idxmax()
ticker = df_consumablesforproduction.loc[max_index, 'ticker']
name = df_consumablesforproduction.loc[max_index, 'name']
gpr = df.loc[max_index, 'gpr2020']
print("Nejvyšší Gross Profit ratio 2020, společnosti zaměřené na consumables for production")
print(ticker)
print(name)
print(gpr * 100, "%")
print()

max_index = df_foundry['gpr2020'].idxmax()
ticker = df_foundry.loc[max_index, 'ticker']
name = df_foundry.loc[max_index, 'name']
gpr = df.loc[max_index, 'gpr2020']
print("Nejvyšší Gross Profit ratio 2020, společnosti zaměřené na foundry")
print(ticker)
print(name)
print(gpr * 100, "%")
print()

max_index = df_products['gpr2020'].idxmax()
ticker = df_products.loc[max_index, 'ticker']
name = df_products.loc[max_index, 'name']
gpr = df.loc[max_index, 'gpr2020']
print("Nejvyšší Gross Profit ratio 2020, společnosti zaměřené na produkty")
print(ticker)
print(name)
print(gpr * 100, "%")
print()


# # Graf revenue dummy

# In[ ]:


#df_chipdesign
#df_consumablesforproduction
#df_foundry
#df_products


# In[70]:


df_products


# In[ ]:


#df_products.sum(axis=0)


# In[ ]:


#sum_column = df_products.sum(axis=0)
#rint (sum_column[['r2010', 'r2011']])


# # Součet revenue v jednotlivých dummies

# In[71]:


sum_chipdesign = df_chipdesign[['r2010', 'r2011', 'r2012', 'r2013', 'r2014', 'r2015', 'r2016', 'r2017', 
                            'r2018', 'r2019', 'r2020', 'r2021']].sum(axis=0)
print ("Revenue společností zaměřených na chipdesign")
print (sum_chipdesign)
print ()

sum_consumablesforproduction = df_consumablesforproduction[['r2010', 'r2011', 'r2012', 'r2013', 
                                                            'r2014', 'r2015', 'r2016', 'r2017', 
                                                            'r2018', 'r2019', 'r2020', 'r2021']].sum(axis=0)
print ("Revenue společností zaměřených na consumables pro produkci")
print (sum_consumablesforproduction)
print ()

sum_foundry = df_foundry[['r2010', 'r2011', 'r2012', 'r2013', 'r2014', 'r2015', 'r2016', 'r2017', 
                            'r2018', 'r2019', 'r2020', 'r2021']].sum(axis=0)
print ("Revenue společností zaměřených na foundry")
print (sum_foundry)
print ()

sum_products = df_products[['r2010', 'r2011', 'r2012', 'r2013', 'r2014', 'r2015', 'r2016', 'r2017', 
                            'r2018', 'r2019', 'r2020', 'r2021']].sum(axis=0)
print ("Revenue společností zaměřených na produkty")
print (sum_products)


# # Graf revenue dummies

# In[72]:


df_chipdesign = df.loc[(df['classification'] == "chip design")]
df_consumablesforproduction = df.loc[(df['Classification_consumables for production'] == 1)]
df_foundry = df.loc[(df['Classification_foundry'] == 1)]
df_products = df.loc[(df['Classification_products'] == 1)]


# In[73]:


sums = {#'classification':df['classification'],
        'sum_chipdesign':sum_chipdesign,
        'sum_consumablesforproduction':sum_consumablesforproduction,
        'sum_foundry':sum_foundry,
        'sum_products':sum_products,
        }


# Convert the dictionary into DataFrame 
s = pd.DataFrame(sums)
  
 
s[[#'classification', 
   'sum_chipdesign', 'sum_consumablesforproduction', 'sum_foundry', 'sum_products'
  ]]


# In[74]:


plotdatasum = pd.DataFrame(sums)

#plotdata.set_index('index', inplace=True)

plotdatasum.head(10)


# In[75]:


plotdatasum.transpose()


# In[76]:


g3 = plotdatasum.plot(kind="area", stacked=True)
#plt.title("Tržby podle klasifikace firem")
plt.xlabel("Rok")
plt.ylabel("Tržby (mld. $)")
plt.rcParams["figure.figsize"] = [20, 12]

plt.xlim([0, 11])
x = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
labels = ['2010', '2011', '2012', '2013', '2014', '2015', '2016', '2017', '2018', '2019', '2020', '2021']
plt.xticks(x, labels)

ylabels = ['{:,.0f}'.format(x) for x in g3.get_yticks()/1000]
g3.set_yticklabels(ylabels)

TITLE_SIZE = 17
HUGE_SIZE = 19

plt.rc('legend', fontsize=HUGE_SIZE)    # legend fontsize

current_handles, current_labels = plt.gca().get_legend_handles_labels()
reversed_handles = list(reversed(current_handles))
reversed_labels = list(reversed(current_labels))
plt.legend(reversed_handles,reversed_labels)

L=plt.legend(reversed_handles,reversed_labels)
L.get_texts()[0].set_text('Výrobní stroje')
L.get_texts()[1].set_text('Foundry')
L.get_texts()[2].set_text('Spotřební materiál ')
L.get_texts()[3].set_text('Chip design ')

#plt.legend(bbox_to_anchor=(1.0, 1.0))
#plt.legend(reversed(plt.legend().legendHandles), reversed(labels))
#plt.legend(reversed(handles), reversed(labels))


# In[71]:


g4 = plotdatasum.plot()
#plt.title("Tržby podle klasifikace firem")
plt.xlabel("Rok")
plt.ylabel("Tržby (mld. $)")
plt.rcParams["figure.figsize"] = [20, 12]

plt.xlim([0, 11])
plt.ylim([0, 500000])
x = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
labels = ['2010', '2011', '2012', '2013', '2014', '2015', '2016', '2017', '2018', '2019', '2020', '2021']
plt.xticks(x, labels)

ylabels = ['{:,.0f}'.format(x) for x in g4.get_yticks()/1000]
g4.set_yticklabels(ylabels)

#current_handles, current_labels = plt.gca().get_legend_handles_labels()
#reversed_handles = list(reversed(current_handles))
#reversed_labels = list(reversed(current_labels))
#plt.legend(reversed_handles,reversed_labels)

L=plt.legend()
L.get_texts()[0].set_text('Chip design')
L.get_texts()[1].set_text('Spotřební materiál')
L.get_texts()[2].set_text('Foundry ')
L.get_texts()[3].set_text('Výrobní stroje ')

#plt.legend(bbox_to_anchor=(1.0, 1.0))
#plt.legend(reversed(plt.legend().legendHandles), reversed(labels))
#plt.legend(reversed(handles), reversed(labels))


# # Skládaný graf tržby kategorie (100%)

# In[72]:


plotdatasum.apply(lambda x: x*100/sum(x), axis=1).plot(kind="area", stacked=True)
#plt.title("Tržby podle klasifikace firem")
plt.xlabel("Rok")
plt.ylabel("Tržby (%)")
plt.rcParams["figure.figsize"] = [20, 12]
plt.xlim([0, 11])
plt.ylim([0, 100])
x = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
xlabels = ['2010', '2011', '2012', '2013', '2014', '2015', '2016', '2017', '2018', '2019', '2020', '2021']
plt.xticks(x, xlabels)

y = [0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100]
ylabels = ['0 %', '10 %', '20 %', '30 %', '40 %', '50 %', '60 %', '70 %', '80 %', '90 %', '100 %']
plt.yticks(y, ylabels)

current_handles, current_labels = plt.gca().get_legend_handles_labels()
reversed_handles = list(reversed(current_handles))
reversed_labels = list(reversed(current_labels))
plt.legend(reversed_handles,reversed_labels)

L=plt.legend(reversed_handles,reversed_labels)
L.get_texts()[0].set_text('Výrobní stroje')
L.get_texts()[1].set_text('Foundry')
L.get_texts()[2].set_text('Spotřební materiál ')
L.get_texts()[3].set_text('Chip design ')

#plt.legend(bbox_to_anchor=(1.0, 1.0))
#plt.legend(reversed(handles), reversed(labels))


# # Net income ratio

# In[45]:


print(df[['ticker', 'classification', 'nir2010', 'nir2011', 'nir2012', 'nir2013', 'nir2014', 'nir2015', 'nir2016',
        'nir2017', 'nir2018', 'nir2019', 'nir2020', 'nir2021'
]])


# In[46]:


nirdata = {'ticker':df['ticker'],
            'classification':df['classification'],
            'nir2010':df['nir2010'],
            'nir2011':df['nir2011'],
            'nir2012':df['nir2012'],
            'nir2013':df['nir2013'],
            'nir2014':df['nir2014'],
            'nir2015':df['nir2015'],
            'nir2016':df['nir2016'],
            'nir2017':df['nir2017'],
            'nir2018':df['nir2018'],
            'nir2019':df['nir2019'],
            'nir2020':df['nir2020'],
            'nir2021':df['nir2021'],
        }


# Convert the dictionary into DataFrame 
nir = pd.DataFrame(nirdata)
  
 
nir[['ticker', 'classification', 'nir2010', 'nir2011', 'nir2012', 'nir2013', 'nir2014', 'nir2015', 'nir2016',
        'nir2017', 'nir2018', 'nir2019', 'nir2020', 'nir2021']]


# In[47]:


# nastavení ticker jako index
nirdata = pd.DataFrame(nirdata)

nirdata.set_index('ticker', inplace=True)


nirdata.head(10)


# In[48]:


nirdata['nir2010'] = nirdata['nir2010'].str.rstrip('%')
nirdata['nir2010'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2010'].values]

nirdata['nir2011'] = nirdata['nir2011'].str.rstrip('%')
nirdata['nir2011'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2011'].values]

nirdata['nir2012'] = nirdata['nir2012'].str.rstrip('%')
nirdata['nir2012'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2012'].values]

nirdata['nir2013'] = nirdata['nir2013'].str.rstrip('%')
nirdata['nir2013'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2013'].values]

nirdata['nir2014'] = nirdata['nir2014'].str.rstrip('%')
nirdata['nir2014'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2014'].values]

nirdata['nir2015'] = nirdata['nir2015'].str.rstrip('%')
nirdata['nir2015'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2015'].values]

nirdata['nir2016'] = nirdata['nir2016'].str.rstrip('%')
nirdata['nir2016'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2016'].values]

nirdata['nir2017'] = nirdata['nir2017'].str.rstrip('%')
nirdata['nir2017'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2017'].values]

nirdata['nir2018'] = nirdata['nir2018'].str.rstrip('%')
nirdata['nir2018'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2018'].values]

nirdata['nir2019'] = nirdata['nir2019'].str.rstrip('%')
nirdata['nir2019'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2019'].values]

nirdata['nir2020'] = nirdata['nir2020'].str.rstrip('%')
nirdata['nir2020'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2020'].values]

nirdata['nir2021'] = nirdata['nir2021'].str.rstrip('%')
nirdata['nir2021'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2021'].values]


# In[49]:


nirdata['nir2010'] = (nirdata['nir2010'] / 100)
nirdata['nir2011'] = (nirdata['nir2011'] / 100)
nirdata['nir2012'] = (nirdata['nir2012'] / 100)
nirdata['nir2013'] = (nirdata['nir2013'] / 100)
nirdata['nir2014'] = (nirdata['nir2014'] / 100)
nirdata['nir2015'] = (nirdata['nir2015'] / 100)
nirdata['nir2016'] = (nirdata['nir2016'] / 100)
nirdata['nir2017'] = (nirdata['nir2017'] / 100)
nirdata['nir2018'] = (nirdata['nir2018'] / 100)
nirdata['nir2019'] = (nirdata['nir2019'] / 100)
nirdata['nir2020'] = (nirdata['nir2020'] / 100)
nirdata['nir2021'] = (nirdata['nir2021'] / 100)


# In[50]:


print(nirdata)


# In[51]:


nirdata['nirmean'] = nirdata.mean(axis=1)
print(nirdata['nirmean'])


# # Net income ratio (průměr 2010 - 2021) graf

# In[36]:


import seaborn as sns


# In[53]:


chart = sns.scatterplot(data=nirdata, x="ticker", y="nirmean", hue="classification", s=100)
#chart.set(ylim=(-0.2, 0.4))
#chart.legend(loc='center left', bbox_to_anchor=(1, 0.5), ncol=1)
sns.set(rc={'figure.figsize':(20,10)})
plt.xticks(rotation=45)
#ax.set_facecolor("gray")
#plt.title("Průměrný výsledek hospodaření za roky 2010 - 2021", fontsize=17)
plt.xlabel("Ticker")
plt.ylabel("Průměrný čistý zisk (%)")

y = [-0.1, -0.05, 0.0, 0.05, 0.1, 0.15, 0.2, 0.25, 0.3, 0.35]
ylabels = ['-10 %','-5 %', '0 %', '5 %', '10 %', '15 %', '20 %', '25 %', '30 %', '35 %']
plt.yticks(y, ylabels)

SMALL_SIZE = 10
MEDIUM_SIZE = 13
BIGGER_SIZE = 15
TITLE_SIZE = 17
HUGE_SIZE = 19

plt.rc('font', size=SMALL_SIZE)           # controls default text sizes
plt.rc('axes', titlesize=HUGE_SIZE)     # fontsize of the axes title
plt.rc('axes', labelsize=HUGE_SIZE)     # fontsize of the x and y labels
plt.rc('xtick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('ytick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('legend', fontsize=HUGE_SIZE)    # legend fontsize
plt.rc('figure', titlesize=HUGE_SIZE)   # fontsize of the figure title

L=plt.legend()
L.get_texts()[0].set_text('Chip design')
L.get_texts()[1].set_text('Foundry')
L.get_texts()[2].set_text('Spotřební materiál')
L.get_texts()[3].set_text('Výrobní stroje ')

#locs, labels = plt.xticks()
#plt.setp(labels, rotation=45)
#chart.set_xticklabels(chart.get_xticklabels(),rotation = 30)
#chart.set_size_inches(12, 8)


# # Net income ratio (průměr 2010 - 2021) Box plot

# In[40]:


#sns.set_theme(style="whitegrid")
sns.set_theme()
#tips = sns.load_dataset("tips")
#ax = sns.boxplot(x=tips["total_bill"])
ax = sns.boxplot(x="classification", y="nirmean", data=nirdata)

x = [0, 1, 2, 3]
labels = ['Chip design', 'Foundry', 'Spotřební materiál', 'Výrobní stroje']
plt.xticks(x, labels)

y = [-0.1, -0.05, 0.0, 0.05, 0.1, 0.15, 0.2, 0.25, 0.3, 0.35]
ylabels = ['-10 %','-5 %', '0 %', '5 %', '10 %', '15 %', '20 %', '25 %', '30 %', '35 %']
plt.yticks(y, ylabels)

#plt.title("Průměrný výsledek hospodaření za roky 2010 - 2021 Box plot", fontsize=17)
plt.xlabel("Klasifikace", fontsize=19)
plt.ylabel("Průměrný čistý zisk (%)", fontsize=19)

for label in (ax.get_xticklabels() + ax.get_yticklabels()):
	label.set_fontsize(19)

SMALL_SIZE = 10
MEDIUM_SIZE = 13
BIGGER_SIZE = 15
TITLE_SIZE = 17
HUGE_SIZE = 19

plt.rc('font', size=HUGE_SIZE)           # controls default text sizes
plt.rc('axes', titlesize=HUGE_SIZE)     # fontsize of the axes title
plt.rc('axes', labelsize=HUGE_SIZE)     # fontsize of the x and y labels
plt.rc('xtick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('ytick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('legend', fontsize=HUGE_SIZE)    # legend fontsize
plt.rc('figure', titlesize=HUGE_SIZE)   # fontsize of the figure title


# # MarketCap

# In[77]:


print(df[['ticker', 'classification', 'marketCap']])


# In[78]:


marketCap = {'ticker':df['ticker'],
            'classification':df['classification'],
            'marketCap':df['marketCap'],
           }


# Convert the dictionary into DataFrame 
mcap = pd.DataFrame(marketCap)
  
 
mcap[['ticker', 'classification', 'marketCap']]


# In[79]:


marketCap['marketCap'] = [float(str(val).replace(' ','').replace(',','.')) for val in marketCap['marketCap'].values]


# In[80]:


marketCap = pd.DataFrame(marketCap)

marketCap.set_index('ticker', inplace=True)


marketCap.head(10)


# In[81]:


print(marketCap)


# # MarketCap scatterplot kategorie

# In[83]:


mcap = sns.scatterplot(data=marketCap, x="ticker", y="marketCap", hue="classification", s=100)
#chart.set(ylim=(-0.2, 0.4))
#chart.legend(loc='center left', bbox_to_anchor=(1, 0.5), ncol=1)
sns.set(rc={'figure.figsize':(20,10)})
plt.xticks(rotation=45)
#ax.set_facecolor("gray")
#plt.title("Tržní kapitalizace", fontsize=17)
plt.xlabel("Ticker")
plt.ylabel("Tržní kapitalizace (mld. $)")

marketCap.sort_values('marketCap', ascending=False, inplace=True)

y = [0, 50, 100, 150, 200, 250, 300, 350, 400, 450]
ylabels = ['0', '50', '100', '150', '200', '250', '300', '350', '400', '450']
plt.yticks(y, ylabels)

SMALL_SIZE = 10
MEDIUM_SIZE = 13
BIGGER_SIZE = 15
TITLE_SIZE = 17
HUGE_SIZE = 19

plt.rc('font', size=HUGE_SIZE)           # controls default text sizes
plt.rc('axes', titlesize=HUGE_SIZE)     # fontsize of the axes title
plt.rc('axes', labelsize=HUGE_SIZE)     # fontsize of the x and y labels
plt.rc('xtick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('ytick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('legend', fontsize=HUGE_SIZE)    # legend fontsize
plt.rc('figure', titlesize=HUGE_SIZE)   # fontsize of the figure title

L=plt.legend()
L.get_texts()[0].set_text('Foundry')
L.get_texts()[1].set_text('Chip design')
L.get_texts()[2].set_text('Výrobní stroje')
L.get_texts()[3].set_text('Spotřební materiál ')


# # Průměrný výsledek hospodaření X Market Cap

# In[84]:


marketNir = {'ticker':df['ticker'],
            'classification':df['classification'],
            'marketCap':df['marketCap'],
            #'nirmean':nirdata['nirmean'],
           }


# In[85]:


marketNir = pd.DataFrame(marketNir)

marketNir.set_index('ticker', inplace=True)

marketNir.head(10)


# In[86]:


marketNir['nirmean'] = nirdata.mean(axis=1)
print(marketNir['nirmean'])


# In[87]:


marketNir['marketCap'] = [float(str(val).replace(' ','').replace(',','.')) for val in marketNir['marketCap'].values]


# In[88]:


marketNir


# In[ ]:


marketNir


# # Průměrný výsledek hospodaření X Market Cap graf

# In[89]:


mrktnir = sns.scatterplot(data=marketNir, x="ticker", y="nirmean", hue="marketCap", s=5*marketNir['marketCap'], 
                          edgecolor='black')
#chart.set(ylim=(-0.2, 0.4))
mrktnir.legend(title='Tržní kapitalizace (mld. $)', title_fontsize=19)
sns.set(rc={'figure.figsize':(20,10)})
plt.xticks(rotation=45)
#ax.set_facecolor("gray")
#plt.title("Průměrný výsledek hospodaření x Tržní kapitalizace", fontsize=17)
plt.xlabel("Ticker")
plt.ylabel("Průměrný čistý zisk (%) x Tržní kapitalizace (mld. $)")

y = [-0.1, -0.05, 0.0, 0.05, 0.1, 0.15, 0.2, 0.25, 0.3, 0.35]
ylabels = ['-10 %','-5 %', '0 %', '5 %', '10 %', '15 %', '20 %', '25 %', '30 %', '35 %']
plt.yticks(y, ylabels)

SMALL_SIZE = 10
MEDIUM_SIZE = 13
BIGGER_SIZE = 15
TITLE_SIZE = 17
HUGE_SIZE = 19

plt.rc('font', size=HUGE_SIZE)           # controls default text sizes
plt.rc('axes', titlesize=HUGE_SIZE)     # fontsize of the axes title
plt.rc('axes', labelsize=HUGE_SIZE)     # fontsize of the x and y labels
plt.rc('xtick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('ytick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('legend', fontsize=HUGE_SIZE)    # legend fontsize
plt.rc('figure', titlesize=HUGE_SIZE)   # fontsize of the figure title

#L=plt.legend()
#L.get_texts()[0].set_text('Chip design')
#L.get_texts()[1].set_text('Foundry')
#L.get_texts()[2].set_text('Spotřební materiál')
#L.get_texts()[3].set_text('Výrobní stroje ')


# # Průměrný výsledek hospodaření X Market Cap BoxPlot

# In[90]:


#sns.set_theme(style="whitegrid")
#sns.set_theme()
#tips = sns.load_dataset("tips")
#ax = sns.boxplot(x=tips["total_bill"])
ax = sns.boxplot(x=pd.cut(marketNir['marketCap'], [0, 25, 50, 100, 200, 450]), y="nirmean", data=marketNir)
#[0, 25, 50, 100, 200, 450]


#x = [(0, 25], (25, 50], (50, 100], (100, 200], (200, 450]]
#xlabels = ['0-25', '25-50', '50-100', '100-200', '200-450']
#plt.xticks(xlabels)

y = [-0.1, -0.05, 0.0, 0.05, 0.1, 0.15, 0.2, 0.25, 0.3, 0.35]
ylabels = ['-10 %','-5 %', '0 %', '5 %', '10 %', '15 %', '20 %', '25 %', '30 %', '35 %']
plt.yticks(y, ylabels)

#plt.title("Průměrný výsledek hospodaření za roky 2010 - 2021 Box plot", fontsize=17)
plt.xlabel("Tržní kapitalizace (mld. $)", fontsize=19)
plt.ylabel("Průměrný čistý zisk (%)", fontsize=19)

for label in (ax.get_xticklabels() + ax.get_yticklabels()):
	label.set_fontsize(19)

SMALL_SIZE = 10
MEDIUM_SIZE = 13
BIGGER_SIZE = 15
TITLE_SIZE = 17
HUGE_SIZE = 19

plt.rc('font', size=HUGE_SIZE)           # controls default text sizes
plt.rc('axes', titlesize=HUGE_SIZE)     # fontsize of the axes title
plt.rc('axes', labelsize=HUGE_SIZE)     # fontsize of the x and y labels
plt.rc('xtick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('ytick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('legend', fontsize=HUGE_SIZE)    # legend fontsize
plt.rc('figure', titlesize=HUGE_SIZE)   # fontsize of the figure title


# # Graf Tržby X Průměrný výsledek hospodaření (data)

# In[91]:


revNir = {'ticker':df['ticker'],
          'tick':df['ticker'],
            'classification':df['classification'],
            'marketCap':df['marketCap'],
            #'nirmean':nirdata['nirmean'],
           }


# In[92]:


revNir = pd.DataFrame(revNir)

revNir.set_index('ticker', inplace=True)

revNir.head(10)


# In[93]:


revNir['nirmean'] = nirdata.mean(axis=1)
print(revNir['nirmean'])


# In[94]:


revNir['marketCap'] = [float(str(val).replace(' ','').replace(',','.')) for val in revNir['marketCap'].values]


# In[95]:


revNir


# In[96]:


revdata = {'ticker':df['ticker'],
           
            'classification':df['classification'],
            'r2010':df['r2010'],
            'r2011':df['r2011'],
            'r2012':df['r2012'],
            'r2013':df['r2013'],
            'r2014':df['r2014'],
            'r2015':df['r2015'],
            'r2016':df['r2016'],
            'r2017':df['r2017'],
            'r2018':df['r2018'],
            'r2019':df['r2019'],
            'r2020':df['r2020'],
            'r2021':df['r2021'],
                    }


# In[97]:


revdata = pd.DataFrame(revdata)

revdata.set_index('ticker', inplace=True)


revdata.head(10)


# In[98]:


revdata


# In[99]:


revNir['rmean'] = revdata.mean(axis=1)
print(revNir['rmean']) 


# In[100]:


revNir


# # Graf Tržby X Průměrný výsledek hospodaření

# In[101]:


revgnir = sns.scatterplot(data=revNir, x="nirmean", y="rmean", hue="classification", s=5*marketNir['marketCap'], 
                          edgecolor='black')
#chart.set(ylim=(-0.2, 0.4))
revgnir.legend(title='Klasifikace', title_fontsize=19)
sns.set(rc={'figure.figsize':(20,10)})
#plt.xticks(rotation=45)
#ax.set_facecolor("gray")
#plt.title("Průměrný výsledek hospodaření x Tržní kapitalizace", fontsize=17)
plt.xlabel("Průměrný čistý zisk (%)")
plt.ylabel("Průměrné tržby (mld. $)")

ylabels = ['{:,.0f}'.format(x) for x in revgnir.get_yticks()/1000]
revgnir.set_yticklabels(ylabels)

x = [-0.1, -0.05, 0.0, 0.05, 0.1, 0.15, 0.2, 0.25, 0.3, 0.35]
xlabels = ['-10 %','-5 %', '0 %', '5 %', '10 %', '15 %', '20 %', '25 %', '30 %', '35 %']
plt.xticks(x, xlabels)

#for i in range(revNir.shape[0]):
# plt.text(x=revNir.nirmean[i]+0,y=revNir.rmean[i]+0,s=revNir.tick[i], 
#          fontdict=dict(color='black',size=10),
#          )

plt.text(revNir.nirmean[revNir.tick=='SSNLF'],revNir.rmean[revNir.tick=='SSNLF'],"SSNLF", color='black', size=17)
plt.text(revNir.nirmean[revNir.tick=='INTC'],revNir.rmean[revNir.tick=='INTC'],"INTC", color='black', size=14)
plt.text(revNir.nirmean[revNir.tick=='TXN'],revNir.rmean[revNir.tick=='TXN'],"TXN", color='black', size=14)
plt.text(revNir.nirmean[revNir.tick=='WOLF'],revNir.rmean[revNir.tick=='WOLF'],"WOLF", color='black', size=12)
plt.text(revNir.nirmean[revNir.tick=='AMD'],revNir.rmean[revNir.tick=='AMD'],"AMD", color='black', size=14)
plt.text(revNir.nirmean[revNir.tick=='QCOM'],revNir.rmean[revNir.tick=='QCOM'],"QCOM", color='black', size=14)
plt.text(revNir.nirmean[revNir.tick=='ASML'],revNir.rmean[revNir.tick=='ASML'],"ASML", color='black', size=14)
plt.text(revNir.nirmean[revNir.tick=='TSM'],revNir.rmean[revNir.tick=='TSM'],"TSM", color='black', size=17)
plt.text(revNir.nirmean[revNir.tick=='NVDA'],revNir.rmean[revNir.tick=='NVDA'],"NVDA", color='black', size=17)
plt.text(revNir.nirmean[revNir.tick=='AVGO'],revNir.rmean[revNir.tick=='AVGO'],"AVGO", color='black', size=14)
plt.text(revNir.nirmean[revNir.tick=='MU'],revNir.rmean[revNir.tick=='MU'],"MU", color='black', size=12)
plt.text(revNir.nirmean[revNir.tick=='AMAT'],revNir.rmean[revNir.tick=='AMAT'],"AMAT", color='black', size=12)
plt.text(revNir.nirmean[revNir.tick=='STM'],revNir.rmean[revNir.tick=='STM'],"STM", color='black', size=12)
plt.text(revNir.nirmean[revNir.tick=='QRVO'],revNir.rmean[revNir.tick=='QRVO'],"QRVO", color='black', size=12)


SMALL_SIZE = 10
MEDIUM_SIZE = 13
BIGGER_SIZE = 15
TITLE_SIZE = 17
HUGE_SIZE = 19

plt.rc('font', size=HUGE_SIZE)           # controls default text sizes
plt.rc('axes', titlesize=HUGE_SIZE)     # fontsize of the axes title
plt.rc('axes', labelsize=HUGE_SIZE)     # fontsize of the x and y labels
plt.rc('xtick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('ytick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('legend', fontsize=HUGE_SIZE)    # legend fontsize
plt.rc('figure', titlesize=HUGE_SIZE)   # fontsize of the figure title

L=plt.legend()
L.get_texts()[0].set_text('Chip design')
L.get_texts()[1].set_text('Foundry')
L.get_texts()[2].set_text('Spotřební materiál')
L.get_texts()[3].set_text('Výrobní stroje ')


# In[102]:


rev2gnir = sns.scatterplot(data=revNir, x="nirmean", y="rmean", hue="classification", s=5*marketNir['marketCap'], 
                          edgecolor='black')

rev2gnir.legend(title='Klasifikace', title_fontsize=19)
sns.set(rc={'figure.figsize':(20,10)})
#plt.xticks(rotation=45)
#ax.set_facecolor("gray")
#plt.title("Průměrný výsledek hospodaření x Tržní kapitalizace", fontsize=17)
plt.xlabel("Průměrný čistý zisk (%)")
plt.ylabel("Průměrné tržby (mld. $)")

plt.ylim([-4000, 69000])
#ylabels = ['{:,.0f}'.format(x) for x in rev2gnir.get_yticks()/1000]
#rev2gnir.set_yticklabels(ylabels)

y = [0, 5000, 10000, 15000, 20000, 25000, 30000, 35000, 40000, 45000, 50000, 55000, 60000, 65000]
ylabels = ['0','5','10','15','20','25','30','35','40','45','50','55','60','65']
plt.yticks(y, ylabels)

x = [-0.1, -0.05, 0.0, 0.05, 0.1, 0.15, 0.2, 0.25, 0.3, 0.35]
xlabels = ['-10 %','-5 %', '0 %', '5 %', '10 %', '15 %', '20 %', '25 %', '30 %', '35 %']
plt.xticks(x, xlabels)
#rev2gnir.set(ylim=(-1000, 60000))


#for i in range(revNir.shape[0]):
# plt.text(x=revNir.nirmean[i]+0,y=revNir.rmean[i]+0,s=revNir.tick[i], 
#          fontdict=dict(color='black',size=10)
#          )

plt.text(revNir.nirmean[revNir.tick=='XLNX'],revNir.rmean[revNir.tick=='XLNX']-2600,"XLNX", color='blue', size=15)
plt.text(revNir.nirmean[revNir.tick=='INTC'],revNir.rmean[revNir.tick=='INTC']+2100,"INTC", color='blue', size=17)
plt.text(revNir.nirmean[revNir.tick=='TXN'],revNir.rmean[revNir.tick=='TXN']+2000,"TXN", color='blue', size=17)
plt.text(revNir.nirmean[revNir.tick=='WOLF'],revNir.rmean[revNir.tick=='WOLF']+500,"WOLF", color='blue', size=15)
plt.text(revNir.nirmean[revNir.tick=='AMD'],revNir.rmean[revNir.tick=='AMD']+2000,"AMD", color='blue', size=17)
plt.text(revNir.nirmean[revNir.tick=='QCOM'],revNir.rmean[revNir.tick=='QCOM']+2000,"QCOM", color='blue', size=17)
plt.text(revNir.nirmean[revNir.tick=='ASML'],revNir.rmean[revNir.tick=='ASML']+2400,"ASML", color='red', size=17)
plt.text(revNir.nirmean[revNir.tick=='TSM'],revNir.rmean[revNir.tick=='TSM']+3300,"TSM", color='orange', size=19)
plt.text(revNir.nirmean[revNir.tick=='NVDA']+0.01,revNir.rmean[revNir.tick=='NVDA']+1200,"NVDA", color='blue', size=19)
plt.text(revNir.nirmean[revNir.tick=='AVGO'],revNir.rmean[revNir.tick=='AVGO']+2300,"AVGO", color='blue', size=17)
plt.text(revNir.nirmean[revNir.tick=='MU'],revNir.rmean[revNir.tick=='MU']+1500,"MU", color='orange', size=15)
plt.text(revNir.nirmean[revNir.tick=='AMAT']+0.004,revNir.rmean[revNir.tick=='AMAT']+1000,"AMAT", color='green', size=15)
plt.text(revNir.nirmean[revNir.tick=='STM'],revNir.rmean[revNir.tick=='STM']+1200,"STM", color='green', size=15)
plt.text(revNir.nirmean[revNir.tick=='QRVO'],revNir.rmean[revNir.tick=='QRVO']+900,"QRVO", color='blue', size=15)

plt.text(revNir.nirmean[revNir.tick=='MRVL']+0.004,revNir.rmean[revNir.tick=='MRVL']-400,"MRVL", color='orange', size=15)
plt.text(revNir.nirmean[revNir.tick=='KLAC']-0.01,revNir.rmean[revNir.tick=='KLAC']+1500,"KLAC", color='green', size=15)
plt.text(revNir.nirmean[revNir.tick=='LRCX']-0.023,revNir.rmean[revNir.tick=='LRCX'],"LRCX", color='green', size=15)
plt.text(revNir.nirmean[revNir.tick=='NXPI'],revNir.rmean[revNir.tick=='NXPI']+1300,"NXPI", color='blue', size=15)
plt.text(revNir.nirmean[revNir.tick=='ADI']+0.0048,revNir.rmean[revNir.tick=='ADI']+1000,"ADI", color='blue', size=15)
plt.text(revNir.nirmean[revNir.tick=='MCHP']+0.002,revNir.rmean[revNir.tick=='MCHP']+1000,"MCHP", color='green', size=15)
plt.text(revNir.nirmean[revNir.tick=='TER']+0.002,revNir.rmean[revNir.tick=='TER'],"TER", color='blue', size=15)
plt.text(revNir.nirmean[revNir.tick=='ON'],revNir.rmean[revNir.tick=='ON']+900,"ON", color='blue', size=15)
plt.text(revNir.nirmean[revNir.tick=='SWKS']-0.009,revNir.rmean[revNir.tick=='SWKS']-2200,"SWKS", color='red', size=15)
plt.text(revNir.nirmean[revNir.tick=='MPWR']-0.01,revNir.rmean[revNir.tick=='MPWR']-2500,"MPWR", color='blue', size=15)
plt.text(revNir.nirmean[revNir.tick=='ENTG']-0.008,revNir.rmean[revNir.tick=='ENTG']-2100,"ENTG", color='green', size=15)
plt.text(revNir.nirmean[revNir.tick=='UMC']+0.0031,revNir.rmean[revNir.tick=='UMC'],"UMC", color='orange', size=15)
plt.text(revNir.nirmean[revNir.tick=='MKSI']-0.01,revNir.rmean[revNir.tick=='MKSI']+700,"MKSI", color='red', size=13)
plt.text(revNir.nirmean[revNir.tick=='LSCC'],revNir.rmean[revNir.tick=='LSCC']+900,"LSCC", color='blue', size=15)
plt.text(revNir.nirmean[revNir.tick=='OLED']+0.001,revNir.rmean[revNir.tick=='OLED'],"OLED", color='green', size=13)
plt.text(revNir.nirmean[revNir.tick=='ASX'],revNir.rmean[revNir.tick=='ASX']+800,"ASX", color='green', size=15)


SMALL_SIZE = 10
MEDIUM_SIZE = 13
BIGGER_SIZE = 15
TITLE_SIZE = 17
HUGE_SIZE = 19

plt.rc('font', size=HUGE_SIZE)           # controls default text sizes
plt.rc('axes', titlesize=HUGE_SIZE)     # fontsize of the axes title
plt.rc('axes', labelsize=HUGE_SIZE)     # fontsize of the x and y labels
plt.rc('xtick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('ytick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('legend', fontsize=HUGE_SIZE)    # legend fontsize
plt.rc('figure', titlesize=HUGE_SIZE)   # fontsize of the figure title

L=plt.legend()
L.get_texts()[0].set_text('Chip design')
L.get_texts()[1].set_text('Foundry')
L.get_texts()[2].set_text('Spotřební materiál')
L.get_texts()[3].set_text('Výrobní stroje ')


# # Regresní model (Tržní kapitalizace x průměrný čistý zisk (%))

# In[103]:


import scipy as sp


# In[104]:


from scipy import stats
slope, intercept, r_value, p_value, std_err = stats.linregress(revNir['nirmean'],revNir['marketCap'])

model = sns.regplot(x="nirmean", y="marketCap", data=revNir,
                   line_kws={'label':"y={0:.2f}x+{1:.3f}".format(slope,intercept)+"\n"+
                            "$R^2$={:.4f}".format(r_value*r_value)})
                   #line_kws={'label':"$R^2$={:.4f}".format(r_value*r_value)})
plt.xlabel("Průměrný čistý zisk (%)")
plt.ylabel("Tržní kapitalizace (mld. $)")

#y = [-200, -150, -100, -50, 0, 50, 100, 150, 200, 250, 300, 350, 400, 450]
#ylabels = ['-200', '-150', '-100', '-50', '0', '50', '100', '150', '200', '250', '300', '350', '400', '450']
#plt.yticks(y, ylabels)

x = [-0.1, -0.05, 0.0, 0.05, 0.1, 0.15, 0.2, 0.25, 0.3, 0.35]
xlabels = ['-10 %','-5 %', '0 %', '5 %', '10 %', '15 %', '20 %', '25 %', '30 %', '35 %']
plt.xticks(x, xlabels)


 #ax.text(.05, .8, 'r={:.2f}, p={:.2g}'.format(r, p),
           # transform=ax.transAxes)

#line_kws={'label':"y={0:.1f}x+{1:.1f}".format(slope,intercept)})
model.legend()


# In[107]:


#r_sq = model.score(x, y)
#print(f"coefficient of determination: {r_sq}")


#def annotate(data, **kws):
#    r, p = sp.stats.pearsonr(data['nirmean'], data['marketCap'])
#    ax = plt.gca()
#    ax.text(.05, .8, 'r={:.2f}, p={:.2g}'.format(r, p),
#            transform=ax.transAxes)
    
#model.map_dataframe(annotate)


# # Debt / Equity průměr

# In[104]:


DEdata = {'ticker':df['ticker'],
            'classification':df['classification'],
            'de2010':df['de2010'],
            'de2011':df['de2011'],
            'de2012':df['de2012'],
            'de2013':df['de2013'],
            'de2014':df['de2014'],
            'de2015':df['de2015'],
            'de2016':df['de2016'],
            'de2017':df['de2017'],
            'de2018':df['de2018'],
            'de2019':df['de2019'],
            'de2020':df['de2020'],
            'de2021':df['de2021'],
        }
de = pd.DataFrame(DEdata)


# In[105]:


DEdata = pd.DataFrame(DEdata)

DEdata.set_index('ticker', inplace=True)

DEdata = DEdata.fillna(0)

DEdata.head(10)


# In[111]:


DEdata = DEdata.fillna(0)


# In[112]:


DEdata.head(10)


# In[106]:


DEdata['de2010'] = DEdata['de2010'].str.rstrip('%')
DEdata['de2010'] = [float(str(val).replace(' ','').replace(',','.')) for val in DEdata['de2010'].values]

DEdata['de2011'] = DEdata['de2011'].str.rstrip('%')
DEdata['de2011'] = [float(str(val).replace(' ','').replace(',','.')) for val in DEdata['de2011'].values]

DEdata['de2012'] = DEdata['de2012'].str.rstrip('%')
DEdata['de2012'] = [float(str(val).replace(' ','').replace(',','.')) for val in DEdata['de2012'].values]

DEdata['de2013'] = DEdata['de2013'].str.rstrip('%')
DEdata['de2013'] = [float(str(val).replace(' ','').replace(',','.')) for val in DEdata['de2013'].values]

DEdata['de2014'] = DEdata['de2014'].str.rstrip('%')
DEdata['de2014'] = [float(str(val).replace(' ','').replace(',','.')) for val in DEdata['de2014'].values]

DEdata['de2015'] = DEdata['de2015'].str.rstrip('%')
DEdata['de2015'] = [float(str(val).replace(' ','').replace(',','.')) for val in DEdata['de2015'].values]

DEdata['de2016'] = DEdata['de2016'].str.rstrip('%')
DEdata['de2016'] = [float(str(val).replace(' ','').replace(',','.')) for val in DEdata['de2016'].values]

DEdata['de2017'] = DEdata['de2017'].str.rstrip('%')
DEdata['de2017'] = [float(str(val).replace(' ','').replace(',','.')) for val in DEdata['de2017'].values]

DEdata['de2018'] = DEdata['de2018'].str.rstrip('%')
DEdata['de2018'] = [float(str(val).replace(' ','').replace(',','.')) for val in DEdata['de2018'].values]

DEdata['de2019'] = DEdata['de2019'].str.rstrip('%')
DEdata['de2019'] = [float(str(val).replace(' ','').replace(',','.')) for val in DEdata['de2019'].values]

DEdata['de2020'] = DEdata['de2020'].str.rstrip('%')
DEdata['de2020'] = [float(str(val).replace(' ','').replace(',','.')) for val in DEdata['de2020'].values]

DEdata['de2021'] = DEdata['de2021'].str.rstrip('%')
DEdata['de2021'] = [float(str(val).replace(' ','').replace(',','.')) for val in DEdata['de2021'].values]


# In[113]:


print(DEdata)


# In[114]:


DEdata['demean'] = DEdata.mean(axis=1)
print(DEdata['demean'])


# # Debt / Equity (průměr 2010 - 2021) graf

# In[115]:


dechart = sns.scatterplot(data=DEdata, x="ticker", y="demean", hue="classification", s=100)
#chart.set(ylim=(-0.2, 0.4))
#chart.legend(loc='center left', bbox_to_anchor=(1, 0.5), ncol=1)
sns.set(rc={'figure.figsize':(20,10)})
plt.xticks(rotation=45)
#ax.set_facecolor("gray")
#plt.title("Průměrný výsledek hospodaření za roky 2010 - 2021", fontsize=17)
plt.xlabel("Ticker")
plt.ylabel("Průměrný poměr dluhu k vlastnímu kapitálu")

#y = [-0.1, -0.05, 0.0, 0.05, 0.1, 0.15, 0.2, 0.25, 0.3, 0.35]
#ylabels = ['-10 %','-5 %', '0 %', '5 %', '10 %', '15 %', '20 %', '25 %', '30 %', '35 %']
#plt.yticks(y, ylabels)

SMALL_SIZE = 10
MEDIUM_SIZE = 13
BIGGER_SIZE = 15
TITLE_SIZE = 17
HUGE_SIZE = 19

plt.rc('font', size=SMALL_SIZE)           # controls default text sizes
plt.rc('axes', titlesize=HUGE_SIZE)     # fontsize of the axes title
plt.rc('axes', labelsize=HUGE_SIZE)     # fontsize of the x and y labels
plt.rc('xtick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('ytick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('legend', fontsize=HUGE_SIZE)    # legend fontsize
plt.rc('figure', titlesize=HUGE_SIZE)   # fontsize of the figure title

L=plt.legend()
L.get_texts()[0].set_text('Chip design')
L.get_texts()[1].set_text('Foundry')
L.get_texts()[2].set_text('Spotřební materiál')
L.get_texts()[3].set_text('Výrobní stroje ')

#locs, labels = plt.xticks()
#plt.setp(labels, rotation=45)
#chart.set_xticklabels(chart.get_xticklabels(),rotation = 30)
#chart.set_size_inches(12, 8)


# # Debt / Equity (průměr 2010 - 2021) Box plot

# In[116]:


#sns.set_theme(style="whitegrid")
sns.set_theme()
#tips = sns.load_dataset("tips")
#ax = sns.boxplot(x=tips["total_bill"])
debx = sns.boxplot(x="classification", y="demean", data=DEdata)

x = [0, 1, 2, 3]
labels = ['Chip design', 'Foundry', 'Spotřební materiál', 'Výrobní stroje']
plt.xticks(x, labels)

#y = [-0.1, -0.05, 0.0, 0.05, 0.1, 0.15, 0.2, 0.25, 0.3, 0.35]
#ylabels = ['-10 %','-5 %', '0 %', '5 %', '10 %', '15 %', '20 %', '25 %', '30 %', '35 %']
#plt.yticks(y, ylabels)

#plt.title("Průměrný výsledek hospodaření za roky 2010 - 2021 Box plot", fontsize=17)
plt.xlabel("Klasifikace", fontsize=19)
plt.ylabel("Průměrný poměr dluhu k vlastnímu kapitálu", fontsize=19)

for label in (debx.get_xticklabels() + debx.get_yticklabels()):
	label.set_fontsize(19)

SMALL_SIZE = 10
MEDIUM_SIZE = 13
BIGGER_SIZE = 15
TITLE_SIZE = 17
HUGE_SIZE = 19

plt.rc('font', size=HUGE_SIZE)           # controls default text sizes
plt.rc('axes', titlesize=HUGE_SIZE)     # fontsize of the axes title
plt.rc('axes', labelsize=HUGE_SIZE)     # fontsize of the x and y labels
plt.rc('xtick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('ytick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('legend', fontsize=HUGE_SIZE)    # legend fontsize
plt.rc('figure', titlesize=HUGE_SIZE)   # fontsize of the figure title


# # Průměrný poměr dluhu k vlastnímu kapitálu X Market Cap

# In[86]:


marketDE = {'ticker':df['ticker'],
            'classification':df['classification'],
            'marketCap':df['marketCap'],
            #'nirmean':nirdata['nirmean'],
           }


# In[87]:


marketDE = pd.DataFrame(marketDE)

marketDE.set_index('ticker', inplace=True)

marketDE.head(10)


# In[119]:


marketDE = marketDE.fillna(0)


# In[122]:


marketDE['demean'] = DEdata.mean(axis=1)
print(marketDE['demean'])


# In[90]:


marketDE['marketCap'] = [float(str(val).replace(' ','').replace(',','.')) for val in marketDE['marketCap'].values]


# In[123]:


marketDE


# # Průměrný poměr dluhu k vlastnímu kapitálu X Market Cap graf

# In[124]:


mrktde = sns.scatterplot(data=marketDE, x="ticker", y="demean", hue="marketCap", s=5*marketDE['marketCap'] , 
                          edgecolor='black')
#chart.set(ylim=(-0.2, 0.4))
mrktde.legend(title='Tržní kapitalizace', title_fontsize=19)
sns.set(rc={'figure.figsize':(20,10)})
plt.xticks(rotation=45)
#ax.set_facecolor("gray")
#plt.title("Průměrný výsledek hospodaření x Tržní kapitalizace", fontsize=17)
plt.xlabel("Ticker")
plt.ylabel("Průměrný poměr dluhu k vlastnímu kapitálu x Tržní kapitalizace")

#y = [-0.1, -0.05, 0.0, 0.05, 0.1, 0.15, 0.2, 0.25, 0.3, 0.35]
#ylabels = ['-10 %','-5 %', '0 %', '5 %', '10 %', '15 %', '20 %', '25 %', '30 %', '35 %']
#plt.yticks(y, ylabels)

SMALL_SIZE = 10
MEDIUM_SIZE = 13
BIGGER_SIZE = 15
TITLE_SIZE = 17
HUGE_SIZE = 19

plt.rc('font', size=HUGE_SIZE)           # controls default text sizes
plt.rc('axes', titlesize=HUGE_SIZE)     # fontsize of the axes title
plt.rc('axes', labelsize=HUGE_SIZE)     # fontsize of the x and y labels
plt.rc('xtick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('ytick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('legend', fontsize=HUGE_SIZE)    # legend fontsize
plt.rc('figure', titlesize=HUGE_SIZE)   # fontsize of the figure title

#L=plt.legend()
#L.get_texts()[0].set_text('Chip design')
#L.get_texts()[1].set_text('Foundry')
#L.get_texts()[2].set_text('Spotřební materiál')
#L.get_texts()[3].set_text('Výrobní stroje ')


# # Průměrný poměr dluhu k vlastnímu kapitálu X Market Cap BoxPlot

# In[125]:


#sns.set_theme(style="whitegrid")
#sns.set_theme()
#tips = sns.load_dataset("tips")
#ax = sns.boxplot(x=tips["total_bill"])
dex = sns.boxplot(x=pd.cut(marketDE['marketCap'], [0, 25, 50, 100, 200, 450]), y="demean", data=marketDE)
#[0, 25, 50, 100, 200, 450]


#x = [(0, 25], (25, 50], (50, 100], (100, 200], (200, 450]]
#xlabels = ['0-25', '25-50', '50-100', '100-200', '200-450']
#plt.xticks(xlabels)

#y = [-0.1, -0.05, 0.0, 0.05, 0.1, 0.15, 0.2, 0.25, 0.3, 0.35]
#ylabels = ['-10 %','-5 %', '0 %', '5 %', '10 %', '15 %', '20 %', '25 %', '30 %', '35 %']
#plt.yticks(y, ylabels)

#plt.title("Průměrný výsledek hospodaření za roky 2010 - 2021 Box plot", fontsize=17)
plt.xlabel("Tržní kapitalizace", fontsize=19)
plt.ylabel("Průměrný poměr dluhu k vlastnímu kapitálu", fontsize=19)

for label in (dex.get_xticklabels() + dex.get_yticklabels()):
	label.set_fontsize(19)

SMALL_SIZE = 10
MEDIUM_SIZE = 13
BIGGER_SIZE = 15
TITLE_SIZE = 17
HUGE_SIZE = 19

plt.rc('font', size=HUGE_SIZE)           # controls default text sizes
plt.rc('axes', titlesize=HUGE_SIZE)     # fontsize of the axes title
plt.rc('axes', labelsize=HUGE_SIZE)     # fontsize of the x and y labels
plt.rc('xtick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('ytick', labelsize=HUGE_SIZE)    # fontsize of the tick labels
plt.rc('legend', fontsize=HUGE_SIZE)    # legend fontsize
plt.rc('figure', titlesize=HUGE_SIZE)   # fontsize of the figure title


# # Součet GP v kategoriích

# In[129]:


#převedení na float
df['gp2010'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gp2010'].values]
df['gp2011'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gp2011'].values]
df['gp2012'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gp2012'].values]
df['gp2013'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gp2013'].values]
df['gp2014'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gp2014'].values]
df['gp2015'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gp2015'].values]
df['gp2016'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gp2016'].values]
df['gp2017'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gp2017'].values]
df['gp2018'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gp2018'].values]
df['gp2019'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gp2019'].values]
df['gp2020'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gp2020'].values]
df['gp2021'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['gp2021'].values]


# In[130]:


print(df['gp2010'].dtype)
print(df['gp2011'].dtype)
print(df['gp2012'].dtype)
print(df['gp2013'].dtype)
print(df['gp2014'].dtype)
print(df['gp2015'].dtype)
print(df['gp2016'].dtype)
print(df['gp2017'].dtype)
print(df['gp2018'].dtype)
print(df['gp2019'].dtype)
print(df['gp2020'].dtype)
print(df['gp2021'].dtype)


# In[131]:


print(df['gp2019'])


# In[133]:


df_chipdesign = df.loc[(df['classification'] == "chip design")]
df_consumablesforproduction = df.loc[(df['Classification_consumables for production'] == 1)]
df_foundry = df.loc[(df['Classification_foundry'] == 1)]
df_products = df.loc[(df['Classification_products'] == 1)]


# In[134]:


sumgp_chipdesign = df_chipdesign[['gp2010', 'gp2011', 'gp2012', 'gp2013', 'gp2014', 'gp2015', 'gp2016', 'gp2017', 
                            'gp2018', 'gp2019', 'gp2020', 'gp2021']].sum(axis=0)
print ("Gross Profit společností zaměřených na chipdesign")
print (sumgp_chipdesign)
print ()

sumgp_consumablesforproduction = df_consumablesforproduction[['gp2010', 'gp2011', 'gp2012', 'gp2013', 'gp2014', 
                                                              'gp2015', 'gp2016', 'gp2017', 
                            'gp2018', 'gp2019', 'gp2020', 'gp2021']].sum(axis=0)
print ("Gross Profit společností zaměřených na spotřební materiál pro výrobu")
print (sumgp_consumablesforproduction)
print ()

sumgp_foundry = df_foundry[['gp2010', 'gp2011', 'gp2012', 'gp2013', 'gp2014', 'gp2015', 'gp2016', 'gp2017', 
                            'gp2018', 'gp2019', 'gp2020', 'gp2021']].sum(axis=0)
print ("Gross Profit společností zaměřených na foundry")
print (sumgp_foundry)
print ()

sumgp_products = df_products[['gp2010', 'gp2011', 'gp2012', 'gp2013', 'gp2014', 'gp2015', 'gp2016', 'gp2017', 
                            'gp2018', 'gp2019', 'gp2020', 'gp2021']].sum(axis=0)
print ("Gross Profit společností zaměřených na výrobní stroje, kapitálové statky pro výrobu polovodičů")
print (sumgp_products)


# # Graf Gross Profit Kategorie

# In[135]:


sumsgp = {#'classification':df['classification'],
        'sumgp_chipdesign':sumgp_chipdesign,
        'sumgp_consumablesforproduction':sumgp_consumablesforproduction,
        'sumgp_foundry':sumgp_foundry,
        'sumgp_products':sumgp_products,
        }


# Convert the dictionary into DataFrame 
sgp = pd.DataFrame(sumsgp)
  
 
sgp[[#'classification', 
   'sumgp_chipdesign', 'sumgp_consumablesforproduction', 'sumgp_foundry', 'sumgp_products'
  ]]


# In[136]:


plotdatasumgp = pd.DataFrame(sumsgp)

#plotdatasumgp.set_index('index', inplace=True)

plotdatasumgp.head(10)


# In[137]:


plotdatasumgp.transpose()


# In[144]:


plotdatasumgp.plot()
plt.title("Hrubá marže podle klasifikace firem")
plt.xlabel("Rok")
plt.ylabel("Hrubá marže")
plt.rcParams["figure.figsize"] = [20, 12]
#plt.legend(bbox_to_anchor=(1.0, 1.0))

plt.xlim([0, 11])
plt.ylim([0, 250000])
x = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
labels = ['2010', '2011', '2012', '2013', '2014', '2015', '2016', '2017', '2018', '2019', '2020', '2021']
plt.xticks(x, labels)

L=plt.legend()
L.get_texts()[0].set_text('Chip design')
L.get_texts()[1].set_text('Spotřební materiál')
L.get_texts()[2].set_text('Foundry ')
L.get_texts()[3].set_text('Výrobní stroje ')


# In[148]:


plotdatasumgp.plot(kind="area", stacked=True)
plt.title("Hrubá marže podle klasifikace firem")
plt.xlabel("Rok")
plt.ylabel("Hrubá marže")
plt.rcParams["figure.figsize"] = [20, 12]
plt.legend(bbox_to_anchor=(1.0, 1.0))

plt.xlim([0, 11])
plt.ylim([0, 350000])
x = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
labels = ['2010', '2011', '2012', '2013', '2014', '2015', '2016', '2017', '2018', '2019', '2020', '2021']
plt.xticks(x, labels)

current_handles, current_labels = plt.gca().get_legend_handles_labels()
reversed_handles = list(reversed(current_handles))
reversed_labels = list(reversed(current_labels))
plt.legend(reversed_handles,reversed_labels)

L=plt.legend(reversed_handles,reversed_labels)
L.get_texts()[0].set_text('Výrobní stroje')
L.get_texts()[1].set_text('Foundry')
L.get_texts()[2].set_text('Spotřební materiál ')
L.get_texts()[3].set_text('Chip design ')


# In[149]:


plotdatasumgp.apply(lambda x: x*100/sum(x), axis=1).plot(kind="area", stacked=True)
plt.title("Hrubá marže podle klasifikace firem")
plt.xlabel("Rok")
plt.ylabel("Hrubá marže (%)")
plt.rcParams["figure.figsize"] = [20, 12]
plt.legend(bbox_to_anchor=(1.0, 1.0))

plt.xlim([0, 11])
plt.ylim([0, 100])
x = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
labels = ['2010', '2011', '2012', '2013', '2014', '2015', '2016', '2017', '2018', '2019', '2020', '2021']
plt.xticks(x, labels)

current_handles, current_labels = plt.gca().get_legend_handles_labels()
reversed_handles = list(reversed(current_handles))
reversed_labels = list(reversed(current_labels))
plt.legend(reversed_handles,reversed_labels)

L=plt.legend(reversed_handles,reversed_labels)
L.get_texts()[0].set_text('Výrobní stroje')
L.get_texts()[1].set_text('Foundry')
L.get_texts()[2].set_text('Spotřební materiál ')
L.get_texts()[3].set_text('Chip design ')


# # Průměr GPr v kategoriích

# In[150]:


print(df[['ticker', 'classification', 'gpr2010', 'gpr2011', 'gpr2012', 'gpr2013', 'gpr2014', 'gpr2015', 'gpr2016',
        'gpr2017', 'gpr2018', 'gpr2019', 'gpr2020', 'gpr2021'
]])


# In[151]:


gprdata = {'ticker':df['ticker'],
            'classification':df['classification'],
            'gpr2010':df['gpr2010'],
            'gpr2011':df['gpr2011'],
            'gpr2012':df['gpr2012'],
            'gpr2013':df['gpr2013'],
            'gpr2014':df['gpr2014'],
            'gpr2015':df['gpr2015'],
            'gpr2016':df['gpr2016'],
            'gpr2017':df['gpr2017'],
            'gpr2018':df['gpr2018'],
            'gpr2019':df['gpr2019'],
            'gpr2020':df['gpr2020'],
            'gpr2021':df['gpr2021'],
        }


# Convert the dictionary into DataFrame 
gpr = pd.DataFrame(gprdata)
  
 
gpr[['ticker', 'classification', 'gpr2010', 'gpr2011', 'gpr2012', 'gpr2013', 'gpr2014', 'gpr2015', 'gpr2016',
        'gpr2017', 'gpr2018', 'gpr2019', 'gpr2020', 'gpr2021']]


# In[152]:


gprdata = pd.DataFrame(gprdata)

gprdata.set_index('ticker', inplace=True)


gprdata.head(10)


# In[153]:


#gprdata['gpr2010'] = gprdata['gpr2010'].str.rstrip('%')
#gprdata['gpr2010'] = [float(str(val).replace(' ','').replace(',','.')) for val in gprdata['nir2010'].values]

gprdata['gpr2011'] = gprdata['gpr2011'].str.rstrip('%')
gprdata['gpr2011'] = [float(str(val).replace(' ','').replace(',','.')) for val in gprdata['gpr2011'].values]

gprdata['gpr2012'] = gprdata['gpr2012'].str.rstrip('%')
gprdata['gpr2012'] = [float(str(val).replace(' ','').replace(',','.')) for val in gprdata['gpr2012'].values]

gprdata['gpr2013'] = gprdata['gpr2013'].str.rstrip('%')
gprdata['gpr2013'] = [float(str(val).replace(' ','').replace(',','.')) for val in gprdata['gpr2013'].values]

gprdata['gpr2014'] = gprdata['gpr2014'].str.rstrip('%')
gprdata['gpr2014'] = [float(str(val).replace(' ','').replace(',','.')) for val in gprdata['gpr2014'].values]

gprdata['gpr2015'] = gprdata['gpr2015'].str.rstrip('%')
gprdata['gpr2015'] = [float(str(val).replace(' ','').replace(',','.')) for val in gprdata['gpr2015'].values]

gprdata['gpr2016'] = gprdata['gpr2016'].str.rstrip('%')
gprdata['gpr2016'] = [float(str(val).replace(' ','').replace(',','.')) for val in gprdata['gpr2016'].values]

gprdata['gpr2017'] = gprdata['gpr2017'].str.rstrip('%')
gprdata['gpr2017'] = [float(str(val).replace(' ','').replace(',','.')) for val in gprdata['gpr2017'].values]

gprdata['gpr2018'] = gprdata['gpr2018'].str.rstrip('%')
gprdata['gpr2018'] = [float(str(val).replace(' ','').replace(',','.')) for val in gprdata['gpr2018'].values]

#gprdata['nir2019'] = gprdata['nir2019'].str.rstrip('%')
#gprdata['nir2019'] = [float(str(val).replace(' ','').replace(',','.')) for val in gprdata['nir2019'].values]

#gprdata['nir2020'] = gprdata['nir2020'].str.rstrip('%')
#gprdata['nir2020'] = [float(str(val).replace(' ','').replace(',','.')) for val in gprdata['nir2020'].values]

#gprdata['nir2021'] = gprdata['nir2021'].str.rstrip('%')
#gprdata['nir2021'] = [float(str(val).replace(' ','').replace(',','.')) for val in gprdata['nir2021'].values]


# In[154]:


print(gprdata)


# In[155]:


gprdata['gpr2010'] = (gprdata['gpr2010'] * 100)
#gprdata['gpr2019'] = (gprdata['gpr2019'] * 100)
gprdata['gpr2020'] = (gprdata['gpr2020'] * 100)
gprdata['gpr2021'] = (gprdata['gpr2021'] * 100)


# In[161]:


print(gprdata)


# In[157]:


print(gprdata['gpr2010'].dtype)
print(gprdata['gpr2011'].dtype)
print(gprdata['gpr2012'].dtype)
print(gprdata['gpr2013'].dtype)
print(gprdata['gpr2014'].dtype)
print(gprdata['gpr2015'].dtype)
print(gprdata['gpr2016'].dtype)
print(gprdata['gpr2017'].dtype)
print(gprdata['gpr2018'].dtype)
print(gprdata['gpr2019'].dtype)
print(gprdata['gpr2020'].dtype)
print(gprdata['gpr2021'].dtype)


# In[162]:


dfmeangpr_chipdesign = gprdata.loc[(gprdata['classification'] == "chip design")]
print(dfmeangpr_chipdesign)
print()
dfmeangpr_consumablesforproduction = gprdata.loc[(gprdata['classification'] == "consumables for production ")]
print(dfmeangpr_consumablesforproduction)
print()
dfmeangpr_foundry = gprdata.loc[(gprdata['classification'] == "foundry")]
print(dfmeangpr_foundry)
print()
dfmeangpr_products = gprdata.loc[(gprdata['classification'] == "products")]
print(dfmeangpr_products)


# In[163]:


meangpr_chipdesign = dfmeangpr_chipdesign[['gpr2010', 'gpr2011', 'gpr2012', 'gpr2013', 'gpr2014', 'gpr2015', 'gpr2016', 
                                           'gpr2017', 'gpr2018', 'gpr2019', 'gpr2020', 'gpr2021']].mean(axis=0)
print ("Gross Profit ratio společností zaměřených na chipdesign")
print (meangpr_chipdesign)
print ()

meangpr_consumablesforproduction = dfmeangpr_consumablesforproduction[['gpr2010', 'gpr2011', 'gpr2012', 'gpr2013', 
                                                                'gpr2014', 'gpr2015', 'gpr2016', 'gpr2017', 
                            'gpr2018', 'gpr2019', 'gpr2020', 'gpr2021']].mean(axis=0)
print ("Gross Profit ratio společností zaměřených na spotřební materiál pro výrobu")
print (meangpr_consumablesforproduction)
print ()

meangpr_foundry = dfmeangpr_foundry[['gpr2010', 'gpr2011', 'gpr2012', 'gpr2013', 'gpr2014', 'gpr2015', 'gpr2016', 'gpr2017', 
                            'gpr2018', 'gpr2019', 'gpr2020', 'gpr2021']].mean(axis=0)
print ("Gross Profit ratio společností zaměřených na foundry")
print (meangpr_foundry)
print ()

meangpr_products = dfmeangpr_products[['gpr2010', 'gpr2011', 'gpr2012', 'gpr2013', 'gpr2014', 'gpr2015', 'gpr2016', 'gpr2017', 
                            'gpr2018', 'gpr2019', 'gpr2020', 'gpr2021']].mean(axis=0)
print ("Gross Profit ratio společností zaměřených na výrobní stroje, kapitálové statky pro výrobu polovodičů")
print (meangpr_products)


# # Graf Gross Profit ratio kategorie

# In[164]:


meansgpr = {#'classification':df['classification'],
        'meangpr_chipdesign':meangpr_chipdesign,
        'meangpr_consumablesforproduction':meangpr_consumablesforproduction,
        'meangpr_foundry':meangpr_foundry,
        'meangpr_products':meangpr_products,
        }


# Convert the dictionary into DataFrame 
mgpr = pd.DataFrame(meansgpr)
  
 
mgpr[[#'classification', 
   'meangpr_chipdesign', 'meangpr_consumablesforproduction', 'meangpr_foundry', 'meangpr_products'
  ]]


# In[165]:


plotdatameansgpr = pd.DataFrame(meansgpr)

#plotdata.set_index('index', inplace=True)

plotdatameansgpr.head(10)


# In[166]:


plotdatameansgpr.transpose()


# In[172]:


plotdatameansgpr.plot()
plt.title("Poměr hrubé marže podle klasifikace firem")
plt.xlabel("Rok")
plt.ylabel("Poměr hrubé marže (%)")
plt.rcParams["figure.figsize"] = [20, 12]
plt.legend(bbox_to_anchor=(1.0, 1.0))

plt.xlim([0, 11])
#plt.ylim([30, 56])
x = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
labels = ['2010', '2011', '2012', '2013', '2014', '2015', '2016', '2017', '2018', '2019', '2020', '2021']
plt.xticks(x, labels)

L=plt.legend()
L.get_texts()[0].set_text('Chip design')
L.get_texts()[1].set_text('Spotřební materiál')
L.get_texts()[2].set_text('Foundry ')
L.get_texts()[3].set_text('Výrobní stroje ')


# # Tyhle nemají moc smysl

# In[125]:


plotdatameansgpr.plot(kind="area", stacked=True)
plt.title("Poměr hrubé marže podle klasifikace firem")
plt.xlabel("Rok")
plt.ylabel("Poměr hrubé marže")
plt.rcParams["figure.figsize"] = [20, 12]
plt.legend(bbox_to_anchor=(1.0, 1.0))


# In[126]:


plotdatameansgpr.apply(lambda x: x*100/sum(x), axis=1).plot(kind="area", stacked=True)
plt.title("Gross Profit ratio")
plt.xlabel("Year")
plt.ylabel("Gross Profit ratio (%)")
plt.rcParams["figure.figsize"] = [20, 12]
plt.legend(bbox_to_anchor=(1.0, 1.0))


# # Součet NI v kategoriích

# In[173]:


#převedení na float
df['ni2010'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['ni2010'].values]
df['ni2011'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['ni2011'].values]
df['ni2012'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['ni2012'].values]
df['ni2013'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['ni2013'].values]
df['ni2014'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['ni2014'].values]
df['ni2015'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['ni2015'].values]
df['ni2016'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['ni2016'].values]
df['ni2017'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['ni2017'].values]
df['ni2018'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['ni2018'].values]
df['ni2019'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['ni2019'].values]
df['ni2020'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['ni2020'].values]
df['ni2021'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['ni2021'].values]


# In[174]:


print(df['ni2010'].dtype)
print(df['ni2011'].dtype)
print(df['ni2012'].dtype)
print(df['ni2013'].dtype)
print(df['ni2014'].dtype)
print(df['ni2015'].dtype)
print(df['ni2016'].dtype)
print(df['ni2017'].dtype)
print(df['ni2018'].dtype)
print(df['ni2019'].dtype)
print(df['ni2020'].dtype)
print(df['ni2021'].dtype)


# In[175]:


print(df['ni2019'])


# In[176]:


df_chipdesign = df.loc[(df['classification'] == "chip design")]
df_consumablesforproduction = df.loc[(df['Classification_consumables for production'] == 1)]
df_foundry = df.loc[(df['Classification_foundry'] == 1)]
df_products = df.loc[(df['Classification_products'] == 1)]


# In[177]:


sumni_chipdesign = df_chipdesign[['ni2010', 'ni2011', 'ni2012', 'ni2013', 'ni2014', 'ni2015', 'ni2016', 'ni2017', 
                            'ni2018', 'ni2019', 'ni2020', 'ni2021']].sum(axis=0)
print ("Net Income společností zaměřených na chipdesign")
print (sumni_chipdesign)
print ()

sumni_consumablesforproduction = df_consumablesforproduction[['ni2010', 'ni2011', 'ni2012', 'ni2013', 'ni2014', 
                                                              'ni2015', 'ni2016', 'ni2017', 
                            'ni2018', 'ni2019', 'ni2020', 'ni2021']].sum(axis=0)
print ("Net Income společností zaměřených na spotřební materiál pro výrobu")
print (sumni_consumablesforproduction)
print ()

sumni_foundry = df_foundry[['ni2010', 'ni2011', 'ni2012', 'ni2013', 'ni2014', 'ni2015', 'ni2016', 'ni2017', 
                            'ni2018', 'ni2019', 'ni2020', 'ni2021']].sum(axis=0)
print ("Net Income společností zaměřených na foundry")
print (sumni_foundry)
print ()

sumni_products = df_products[['ni2010', 'ni2011', 'ni2012', 'ni2013', 'ni2014', 'ni2015', 'ni2016', 'ni2017', 
                            'ni2018', 'ni2019', 'ni2020', 'ni2021']].sum(axis=0)
print ("Net Income společností zaměřených na výrobní stroje, kapitálové statky pro výrobu polovodičů")
print (sumni_products)


# # Graf Net Income Kategorie

# In[178]:


sumsni = {#'classification':df['classification'],
        'sumni_chipdesign':sumni_chipdesign,
        'sumni_consumablesforproduction':sumni_consumablesforproduction,
        'sumni_foundry':sumni_foundry,
        'sumni_products':sumni_products,
        }


# Convert the dictionary into DataFrame 
sni = pd.DataFrame(sumsni)
  
 
sni[[#'classification', 
   'sumni_chipdesign', 'sumni_consumablesforproduction', 'sumni_foundry', 'sumni_products'
  ]]


# In[179]:


plotdatasumni = pd.DataFrame(sumsni)

#plotdatasumgp.set_index('index', inplace=True)

plotdatasumni.head(10)


# In[180]:


plotdatasumni.transpose()


# In[183]:


plotdatasumni.plot()
plt.title("Výsledek hospodaření podle klasifikace firem")
plt.xlabel("Rok")
plt.ylabel("Výsledek hospodaření")
plt.rcParams["figure.figsize"] = [20, 12]
#plt.legend(bbox_to_anchor=(1.0, 1.0))

plt.xlim([0, 11])
x = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
labels = ['2010', '2011', '2012', '2013', '2014', '2015', '2016', '2017', '2018', '2019', '2020', '2021']
plt.xticks(x, labels)

L=plt.legend()
L.get_texts()[0].set_text('Chip design')
L.get_texts()[1].set_text('Spotřební materiál')
L.get_texts()[2].set_text('Foundry ')
L.get_texts()[3].set_text('Výrobní stroje ')


# In[220]:


plotdatasumni.plot(kind="area", stacked=True)
plt.title("Net Income categories")
plt.xlabel("Year")
plt.ylabel("Net Income")
plt.rcParams["figure.figsize"] = [20, 12]
plt.legend(bbox_to_anchor=(1.0, 1.0))


# # Průměr NIr v kategoriích

# In[184]:


print(df[['ticker', 'classification', 'nir2010', 'nir2011', 'nir2012', 'nir2013', 'nir2014', 'nir2015', 'nir2016',
        'nir2017', 'nir2018', 'nir2019', 'nir2020', 'nir2021'
]])


# In[185]:


nirdata = {'ticker':df['ticker'],
            'classification':df['classification'],
            'nir2010':df['nir2010'],
            'nir2011':df['nir2011'],
            'nir2012':df['nir2012'],
            'nir2013':df['nir2013'],
            'nir2014':df['nir2014'],
            'nir2015':df['nir2015'],
            'nir2016':df['nir2016'],
            'nir2017':df['nir2017'],
            'nir2018':df['nir2018'],
            'nir2019':df['nir2019'],
            'nir2020':df['nir2020'],
            'nir2021':df['nir2021'],
        }


# Convert the dictionary into DataFrame 
nir = pd.DataFrame(nirdata)
  
 
nir[['ticker', 'classification', 'nir2010', 'nir2011', 'nir2012', 'nir2013', 'nir2014', 'nir2015', 'nir2016',
        'nir2017', 'nir2018', 'nir2019', 'nir2020', 'nir2021']]


# In[186]:


nirdata = pd.DataFrame(nirdata)

#gprdata.set_index('ticker', inplace=True)

nirdata.head(10)


# In[187]:


nirdata['nir2010'] = nirdata['nir2010'].str.rstrip('%')
nirdata['nir2010'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2010'].values]

nirdata['nir2011'] = nirdata['nir2011'].str.rstrip('%')
nirdata['nir2011'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2011'].values]

nirdata['nir2012'] = nirdata['nir2012'].str.rstrip('%')
nirdata['nir2012'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2012'].values]

nirdata['nir2013'] = nirdata['nir2013'].str.rstrip('%')
nirdata['nir2013'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2013'].values]

nirdata['nir2014'] = nirdata['nir2014'].str.rstrip('%')
nirdata['nir2014'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2014'].values]

nirdata['nir2015'] = nirdata['nir2015'].str.rstrip('%')
nirdata['nir2015'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2015'].values]

nirdata['nir2016'] = nirdata['nir2016'].str.rstrip('%')
nirdata['nir2016'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2016'].values]

nirdata['nir2017'] = nirdata['nir2017'].str.rstrip('%')
nirdata['nir2017'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2017'].values]

nirdata['nir2018'] = nirdata['nir2018'].str.rstrip('%')
nirdata['nir2018'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2018'].values]

nirdata['nir2019'] = nirdata['nir2019'].str.rstrip('%')
nirdata['nir2019'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2019'].values]

nirdata['nir2020'] = nirdata['nir2020'].str.rstrip('%')
nirdata['nir2020'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2020'].values]

nirdata['nir2021'] = nirdata['nir2021'].str.rstrip('%')
nirdata['nir2021'] = [float(str(val).replace(' ','').replace(',','.')) for val in nirdata['nir2021'].values]


# In[188]:


print(nirdata)


# In[189]:


print(nirdata['nir2010'].dtype)
print(nirdata['nir2011'].dtype)
print(nirdata['nir2012'].dtype)
print(nirdata['nir2013'].dtype)
print(nirdata['nir2014'].dtype)
print(nirdata['nir2015'].dtype)
print(nirdata['nir2016'].dtype)
print(nirdata['nir2017'].dtype)
print(nirdata['nir2018'].dtype)
print(nirdata['nir2019'].dtype)
print(nirdata['nir2020'].dtype)
print(nirdata['nir2021'].dtype)


# In[190]:


dfmeannir_chipdesign = nirdata.loc[(nirdata['classification'] == "chip design")]
print(dfmeannir_chipdesign)
print()
dfmeannir_consumablesforproduction = nirdata.loc[(nirdata['classification'] == "consumables for production ")]
print(dfmeannir_consumablesforproduction)
print()
dfmeannir_foundry = nirdata.loc[(nirdata['classification'] == "foundry")]
print(dfmeannir_foundry)
print()
dfmeannir_products = nirdata.loc[(nirdata['classification'] == "products")]
print(dfmeannir_products)


# In[191]:


meannir_chipdesign = dfmeannir_chipdesign[['nir2010', 'nir2011', 'nir2012', 'nir2013', 'nir2014', 'nir2015', 'nir2016', 
                                           'nir2017', 'nir2018', 'nir2019', 'nir2020', 'nir2021']].mean(axis=0)
print ("Net Income ratio společností zaměřených na chipdesign")
print (meannir_chipdesign)
print ()

meannir_consumablesforproduction = dfmeannir_consumablesforproduction[['nir2010', 'nir2011', 'nir2012', 'nir2013', 
                                                                       'nir2014', 'nir2015', 'nir2016', 
                                           'nir2017', 'nir2018', 'nir2019', 'nir2020', 'nir2021']].mean(axis=0)
print ("Net Income ratio společností zaměřených na spotřební materiál pro výrobu")
print (meannir_consumablesforproduction)
print ()

meannir_foundry = dfmeannir_foundry[['nir2010', 'nir2011', 'nir2012', 'nir2013', 'nir2014', 'nir2015', 'nir2016', 
                                           'nir2017', 'nir2018', 'nir2019', 'nir2020', 'nir2021']].mean(axis=0)
print ("Net Income ratio společností zaměřených na foundry")
print (meannir_foundry)
print ()

meannir_products = dfmeannir_products[['nir2010', 'nir2011', 'nir2012', 'nir2013', 'nir2014', 'nir2015', 'nir2016', 
                                           'nir2017', 'nir2018', 'nir2019', 'nir2020', 'nir2021']].mean(axis=0)
print ("Net Income ratio společností zaměřených na výrobní stroje, kapitálové statky pro výrobu polovodičů")
print (meannir_products)


# # Graf Net Income ratio kategorie

# In[192]:


meansnir = {#'classification':df['classification'],
        'meannir_chipdesign':meannir_chipdesign,
        'meannir_consumablesforproduction':meannir_consumablesforproduction,
        'meannir_foundry':meannir_foundry,
        'meannir_products':meannir_products,
        }


# Convert the dictionary into DataFrame 
mnir = pd.DataFrame(meansnir)
  
 
mnir[[#'classification', 
   'meannir_chipdesign', 'meannir_consumablesforproduction', 'meannir_foundry', 'meannir_products'
  ]]


# In[193]:


plotdatameansnir = pd.DataFrame(meansnir)

#plotdata.set_index('index', inplace=True)

plotdatameansnir.head(10)


# In[194]:


plotdatameansnir.transpose()


# In[198]:


plotdatameansnir.plot()
plt.title("Poměr výsledeku hospodaření podle klasifikace firem")
plt.xlabel("Rok")
plt.ylabel("Poměr výsledeku hospodaření (%)")
plt.rcParams["figure.figsize"] = [20, 12]
#plt.legend(bbox_to_anchor=(1.0, 1.0))

plt.xlim([0, 11])
plt.ylim([0, 32])
x = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
labels = ['2010', '2011', '2012', '2013', '2014', '2015', '2016', '2017', '2018', '2019', '2020', '2021']
plt.xticks(x, labels)

L=plt.legend()
L.get_texts()[0].set_text('Chip design')
L.get_texts()[1].set_text('Spotřební materiál')
L.get_texts()[2].set_text('Foundry ')
L.get_texts()[3].set_text('Výrobní stroje ')


# In[161]:


# Nemá smysl

plotdatameansnir.plot(kind="area", stacked=True)
plt.title("Net Income ratio categories")
plt.xlabel("Year")
plt.ylabel("Net Income ratio")
plt.rcParams["figure.figsize"] = [20, 12]
plt.legend(bbox_to_anchor=(1.0, 1.0))


# In[199]:


plotdatameansnir.apply(lambda x: x*100/sum(x), axis=1).plot(kind="area", stacked=True)
plt.title("Poměr výsledeku hospodaření podle klasifikace firem")
plt.xlabel("Rok")
plt.ylabel("Poměr výsledeku hospodaření (%)")
plt.rcParams["figure.figsize"] = [20, 12]
plt.legend(bbox_to_anchor=(1.0, 1.0))

plt.xlim([0, 11])
plt.ylim([0, 100])
x = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
labels = ['2010', '2011', '2012', '2013', '2014', '2015', '2016', '2017', '2018', '2019', '2020', '2021']
plt.xticks(x, labels)

current_handles, current_labels = plt.gca().get_legend_handles_labels()
reversed_handles = list(reversed(current_handles))
reversed_labels = list(reversed(current_labels))
plt.legend(reversed_handles,reversed_labels)

L=plt.legend(reversed_handles,reversed_labels)
L.get_texts()[0].set_text('Výrobní stroje')
L.get_texts()[1].set_text('Foundry')
L.get_texts()[2].set_text('Spotřební materiál ')
L.get_texts()[3].set_text('Chip design ')


# # HHI celek

# In[15]:


print(df['r2021'].dtype)


# In[16]:


#převedení na float
df['r2021'] = [float(str(val).replace(' ','').replace(',','.')) for val in df['r2021'].values]
print(df['r2021'].dtype)


# In[17]:


# sečtení tržeb za rok 2021
sumr21 = df['r2021'].sum(axis=0)
print ("Celkové tržby za rok 2021")
print (sumr21)


# In[54]:


# procentuální podíl (tržní podíl firem)
df['r21proc'] = df['r2021']/sumr21*100
print(df[['ticker', 'r21proc']])


# In[21]:


# kontrola -> suma tržních podílů firem
sumr21proc = df['r21proc'].sum(axis=0)
print ("suma tržních podílů firem (musí být 100)")
print (sumr21proc)


# In[22]:


# Výpočet HHI -> procentuální tržní podíl na 2
df['r21proc2'] = df['r21proc']**2
print(df['r21proc2'])


# In[23]:


# Výpočet HHI -> sečtení procentuálních tržních podílů na 2
#The agencies generally consider markets in which the HHI is between 1,500 and 2,500 points to be moderately concentrated, 
#and consider markets in which the HHI is in excess of 2,500 points to be highly concentrated
HHIcelk = df['r21proc2'].sum(axis=0)
print ("HHI pro všechny vybrané firmy polovodičového trhu")
print (HHIcelk)


# # HHI pro jednotlivé kategorie

# In[25]:


df_chipdesign = df.loc[(df['classification'] == "chip design")]
df_consumablesforproduction = df.loc[(df['Classification_consumables for production'] == 1)]
df_foundry = df.loc[(df['Classification_foundry'] == 1)]
df_products = df.loc[(df['Classification_products'] == 1)]


# # HHI chip design

# In[26]:


# sečtení tržeb za rok 2021
sumr21chd = df_chipdesign['r2021'].sum(axis=0)
print ("Celkové tržby firem zaměřených na chip design za rok 2021")
print (sumr21chd)


# In[56]:


# procentuální podíl (tržní podíl firem)
df_chipdesign['r21procCHD'] = df_chipdesign['r2021']/sumr21chd*100
print(df_chipdesign[['ticker','r21procCHD']])


# In[28]:


# kontrola -> suma tržních podílů firem
sumr21procCHD = df_chipdesign['r21procCHD'].sum(axis=0)
print ("suma tržních podílů firem (musí být 100)")
print (sumr21procCHD)


# In[29]:


# Výpočet HHI -> procentuální tržní podíl na 2
df_chipdesign['r21procCHD2'] = df_chipdesign['r21procCHD']**2
print(df_chipdesign['r21procCHD2'])


# In[31]:


# Výpočet HHI -> sečtení procentuálních tržních podílů na 2
#The agencies generally consider markets in which the HHI is between 1,500 and 2,500 points to be moderately concentrated, 
#and consider markets in which the HHI is in excess of 2,500 points to be highly concentrated
HHIchd = df_chipdesign['r21procCHD2'].sum(axis=0)
print ("HHI pro kategorii chip design")
print (HHIchd)


# # HHI foundry

# In[32]:


# sečtení tržeb za rok 2021
sumr21f = df_foundry['r2021'].sum(axis=0)
print ("Celkové tržby firem zaměřených na foundry za rok 2021")
print (sumr21f)


# In[57]:


# procentuální podíl (tržní podíl firem)
df_foundry['r21procF'] = df_foundry['r2021']/sumr21f*100
print(df_foundry[['ticker','r21procF']])


# In[34]:


# kontrola -> suma tržních podílů firem
sumr21procF = df_foundry['r21procF'].sum(axis=0)
print ("suma tržních podílů firem (musí být 100)")
print (sumr21procF)


# In[35]:


# Výpočet HHI -> procentuální tržní podíl na 2
df_foundry['r21procF2'] = df_foundry['r21procF']**2
print(df_foundry['r21procF2'])


# In[36]:


# Výpočet HHI -> sečtení procentuálních tržních podílů na 2
#The agencies generally consider markets in which the HHI is between 1,500 and 2,500 points to be moderately concentrated, 
#and consider markets in which the HHI is in excess of 2,500 points to be highly concentrated
HHIf = df_foundry['r21procF2'].sum(axis=0)
print ("HHI pro kategorii foundry")
print (HHIf)


# # HHI Consumables for production 

# In[42]:


# sečtení tržeb za rok 2021
sumr21cfp = df_consumablesforproduction['r2021'].sum(axis=0)
print ("Celkové tržby firem zaměřených na spotřební materiál za rok 2021")
print (sumr21cfp)


# In[58]:


# procentuální podíl (tržní podíl firem)
df_consumablesforproduction['r21procCFP'] = df_consumablesforproduction['r2021']/sumr21cfp*100
print(df_consumablesforproduction[['ticker','r21procCFP']])


# In[39]:


# kontrola -> suma tržních podílů firem
sumr21procCFP = df_consumablesforproduction['r21procCFP'].sum(axis=0)
print ("suma tržních podílů firem (musí být 100)")
print (sumr21procCFP)


# In[40]:


# Výpočet HHI -> procentuální tržní podíl na 2
df_consumablesforproduction['r21procCFP2'] = df_consumablesforproduction['r21procCFP']**2
print(df_consumablesforproduction['r21procCFP2'])


# In[43]:


# Výpočet HHI -> sečtení procentuálních tržních podílů na 2
#The agencies generally consider markets in which the HHI is between 1,500 and 2,500 points to be moderately concentrated, 
#and consider markets in which the HHI is in excess of 2,500 points to be highly concentrated
HHIcfp = df_consumablesforproduction['r21procCFP2'].sum(axis=0)
print ("HHI pro kategorii spotřební materiál")
print (HHIcfp)


# # HHI Products

# In[45]:


# sečtení tržeb za rok 2021
sumr21p = df_products['r2021'].sum(axis=0)
print ("Celkové tržby firem zaměřených na výrobní stroje za rok 2021")
print (sumr21p)


# In[59]:


# procentuální podíl (tržní podíl firem)
df_products['r21procP'] = df_products['r2021']/sumr21p*100
print(df_products[['ticker','r21procP']])


# In[47]:


# kontrola -> suma tržních podílů firem
sumr21procP = df_products['r21procP'].sum(axis=0)
print ("suma tržních podílů firem (musí být 100)")
print (sumr21procP)


# In[48]:


# Výpočet HHI -> procentuální tržní podíl na 2
df_products['r21procP2'] = df_products['r21procP']**2
print(df_products['r21procP2'])


# In[49]:


# Výpočet HHI -> sečtení procentuálních tržních podílů na 2
#The agencies generally consider markets in which the HHI is between 1,500 and 2,500 points to be moderately concentrated, 
#and consider markets in which the HHI is in excess of 2,500 points to be highly concentrated
HHIp = df_products['r21procP2'].sum(axis=0)
print ("HHI pro kategorii výrobní stroje")
print (HHIp)


# # Všechny HHI

# In[51]:


print ("HHI pro všechny vybrané firmy polovodičového trhu")
print (HHIcelk)
print()
print ("HHI pro kategorii chip design")
print (HHIchd)
print()
print ("HHI pro kategorii foundry")
print (HHIf)
print()
print ("HHI pro kategorii spotřební materiál")
print (HHIcfp)
print()
print ("HHI pro kategorii výrobní stroje")
print (HHIp)


# In[ ]:




